;2S_VERS.LSP

;Mit dem AutoCAD-Standardbefehl VERSETZ werden neue Objekte erstellt, die quasi Kopien ausgewhlter Objekte sind und in einem bestimmten Abstand parallel zu diesen liegen. Dafr werden Sie jeweils aufgefordert am Bildschirm zu zeigen, auf welcher  Seite die neuen Elemente plaziert werden sollen. Bei der tglichen Konstruktionsarbeit kommt es aber immer wieder vor, dass die Objekte nach beiden Seiten hin versetzt werden mssen. Hierfr sind nun schon vier Klicks ntig, nmlich das Picken des zu versetzenden Objekts, das Zeigen der Seite, auf die versetzt werden soll und dann beide Schritte nochmals fr die andere Seite. Schn wre jetzt wenn das alles mit einem Klick machbar wre. Genau diese Mglichkeit bietet das AutoLISP-Tool 2S_VERS.LSP. Nachdem Sie das Tool mit dem Befehl APPLOAD geladen und anschlieend den Befehl durch die Eingabe von 2S_VERS aufgerufen haben, knnen Sie whlen zwischen den Optionen "Abstand" und "Gesamtbreite". Geben Sie einen Abstand ein, entspricht dies der Entfernung zwischen dem alten Objekt und dem neuen, so wie Sie es vom AutoCAD-Befehl VERSETZ kennen. Whlen Sie die Option "Gesamtbreite" legen Sie hierber den Abstand zwischen den beiden neuen Objekten fest, sie entspricht also dem doppelten Wert der Option "Abstand". Dies hat den Vorteil, dass Sie sich die Berechnung des Abstands ersparen knnen, wenn Sie beispielsweise entlang einer Mittelachse einen Weg mit einer bestimmten Breite zeichnen wollen. Anschlieend haben Sie noch die Mglichkeit zu bestimmen, ob das alte Objekt gelscht werden oder erhalten bleiben soll. Haben Sie diese Eingaben gettigt, knnen Sie mit dem Versetzen beginnen,  der Befehl bleibt dabei solange im Wiederholmodus, bis Sie ihn mit RETURN oder ESCAPE abbrechen. Fr alle Optionsanfragen werden Vorgabewerte angeboten, die Sie mit der Return-Taste besttigen und damit auswhlen knnen. Diese Vorgaben werden nach jeder Programmausfhrung aktualisiert und entsprechen immer den gewhlten Optionen des letzten Programmaufrufs. Beim ersten Programmaufruf werden die Optionen "Abstand", als Wert fr den Abstand der Wert der Systemvariablen OFFSETDIST des AutoCAD-Befehls VERSETZ, sowie die Option "Nein" fr das Lschen des alten Objekts verwendet. Danach werden die neuen oder auch bernommenen Werte in globalen Variablen gespeichert und bei weiteren Programmausfhrungen als Vorgabewerte angeboten. Dadurch ist immer ein zgiges Arbeiten gewhrleistet, da sich das Programm an den Gewohnheiten des Anwenders orientiert. Den Wert fr den Abstand oder die Gesamtbreite, je nach gewhlter Option, knnen Sie als numerischen Wert ber die Tastatur eingeben oder durch die Wahl zweier Punkte am Bildschirm festlegen. Hierfr wird vom Programm die AutoLISP-Funktion GETDIST verwendet. Versetzt werden knnen mit dem Tool Elemente des Objekttyps Linie, 2D-Polylinie, Bogen, Kreis, Konstruktionslinie, Strahl und Spline. Haben Sie ein anderes Objekt gewhlt erscheint in der Befehlszeile die Meldung "Dieses Objekt kann nicht versetzt werden." und Sie werden erneut zur Objektwahl aufgefordert.

;Befehlsaufruf: 2S_VERS

;Programmiert von Gerhard Rampf am 24.10.1999
;Modifiziert von Gerhard Rampf am 06.03.2000


;Programmgebundene Fehlerroutine *2S_VERS_ERROR*

(defun *2s_vers_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= offsetdist_akt nil)
(setvar "OFFSETDIST" offsetdist_akt))
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= dimzin_akt nil)
(setvar "DIMZIN" dimzin_akt))
(if (/= osmode_akt nil)
(setvar "OSMODE" osmode_akt))
(if (/= blipmode_akt nil)
(setvar "BLIPMODE" blipmode_akt))
(setq error_akt nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq dimzin_akt nil)
(setq osmode_akt nil)
(setq offsetdist_akt nil)
(setq blipmode_akt nil)
(setq startpunkt nil)
(setq endpunkt nil)
(setq winkel nil)
(setq p1 nil)
(setq p2 nil)
(setq startwinkel_wks nil)
(setq zentrum_wks nil)
(setq zentrum nil)
(setq radius nil)
(setq richtungsvektor nil)
(setq mitte nil)
(setq hauptachse nil)
(setq punktliste nil)
(setq objektname nil)
(setq subentity_1 nil)
(setq subentity_2 nil)
(setq vertex1 nil)
(setq vertex2 nil)
(setq abstand_2s_vers nil)
(setq gesamtbreite_2s_vers nil)
(setq reihenfolge nil)
(setq kante nil)
(setq et_kante nil)
(setq entityliste nil)
(setq objekttyp nil)
(setq option_2 nil)
(setq liste_100 nil)
(setq version_2s_vers_am_6_99 nil)
(princ))


;Unterprogramm PUNKTBERECHNUNG_LINIE

(defun punktberechnung_linie ()
(setq startpunkt (trans (cdr (assoc 10 entityliste)) 0 1))
(setq endpunkt (trans (cdr (assoc 11 entityliste)) 0 1))
(setq winkel (angle startpunkt endpunkt))
(setq p1 (polar startpunkt (+ winkel (/ pi 2.0)) 0.0001))
(setq p2 (polar startpunkt (+ winkel (* pi 1.5)) 0.0001)))


;Unterprogramm PUNKTBERECHNUNG_KREIS

(defun punktberechnung_kreis ()
(setq zentrum (trans (cdr (assoc 10 entityliste)) 0 1))
(setq radius (cdr (assoc 40 entityliste)))
(setq p1 zentrum)
(setq p2 (polar zentrum 0 (+ radius 0.0001))))


;Unterprogramm PUNKTBERECHNUNG_BOGEN

(defun punktberechnung_bogen ()
(setq startwinkel_wks (cdr (assoc 50 entityliste)))
(setq zentrum_wks (cdr (assoc 10 entityliste)))
(setq zentrum (trans (cdr (assoc 10 entityliste)) 0 1))
(setq radius (cdr (assoc 40 entityliste)))
(setq p1 zentrum)
(setq p2 (trans (polar zentrum_wks startwinkel_wks (+ radius 0.0001)) 0 1)))


;Unterprogramm PUNKTBERECHNUNG_STRAHL_KLINIE

(defun punktberechnung_strahl_klinie ()
(setq startpunkt (trans (cdr (assoc 10 entityliste)) 0 1))
(setq richtungsvektor (trans (cdr (assoc 11 entityliste)) 0 1))
(setq winkel (angle '(0.0 0.0 0.0) richtungsvektor))
(setq p1 (polar startpunkt (+ winkel (/ pi 2.0)) 0.0001))
(setq p2 (polar startpunkt (+ winkel (* pi 1.5)) 0.0001)))


;Unterprogramm PUNKTBERECHNUNG_ELLIPSE

(defun punktberechnung_ellipse ()
(setq mitte (trans (cdr (assoc 10 entityliste)) 0 1))
(setq hauptachse (abs (car (cdr (assoc 11 entityliste)))))
(setq p1 mitte)
(setq p2 (polar mitte 0 (+ hauptachse 0.0001))))


;Unterprogramm PUNKTBERECHNUNG_LWPOLYLINIE_SPLINE

(defun punktberechnung_lwpolylinie_spline ()
(setq punktliste (apply 'append
(mapcar
'(lambda (x)
(if (= 10 (car x))
(list (cdr x)))) entityliste)))
(setq startpunkt (car punktliste))
(setq endpunkt (cadr punktliste))
(setq winkel (angle startpunkt endpunkt))
(setq p1 (trans (polar startpunkt (+ winkel (/ pi 2.0)) 0.0001) 0 1))
(setq p2 (trans (polar startpunkt (+ winkel (* pi 1.5)) 0.0001) 0 1)))


;Unterprogramm PUNKTBERECHNUNG_POLYLINIE

(defun punktberechnung_polylinie ()
(setq objektname (car kante))
(setq subentity_1 (entnext objektname))
(setq subentity_2 (entnext subentity_1))
(setq vertex1 (cdr (assoc 10 (entget subentity_1))))
(setq vertex2 (cdr (assoc 10 (entget subentity_2))))
(setq winkel (angle vertex1 vertex2))
(setq p1 (trans (polar vertex1 (+ winkel (/ pi 2.0)) 0.0001) 0 1))
(setq p2 (trans (polar vertex1 (+ winkel (* pi 1.5)) 0.0001) 0 1)))


;Unterprogramm ABSTAND_2S_VERS_AUFRUF1_R15

(defun abstand_2s_vers_aufruf1_r15 ()
(if (<= (getvar "OFFSETDIST") 0)
(progn
(if (> version 14)
(progn
(initget 6 "Gesamtbreite")
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.00000000>: ")))))
(if (< version 15)
(progn
(initget 6 "Gesamtbreite")
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.00000000>: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers 1.0))
(if (/= abstand_2s_vers "Gesamtbreite")
(setq abstand_2s_vers_am699 abstand_2s_vers))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
(setq reihenfolge "aa1")
(if (= abstand_2s_vers "Gesamtbreite")
(progn
(if (> version 14)
(progn
(initget 6)
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.00000000>: ")))))
(if (< version 15)
(progn
(initget 6)
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.00000000>: ")))))
(if (/= abstand_2s_vers nil)
(setq abstand_2s_vers (/ abstand_2s_vers 2.0)))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers 0.5))
(setq abstand_2s_vers_am699 abstand_2s_vers)
(setq reihenfolge "ag1")
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite")))))
(if (> (getvar "OFFSETDIST") 0)
(progn
(if (> version 14)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand angeben oder [Gesamtbreite] <" (rtos (getvar "OFFSETDIST") 2) ">: ")))))
(if (< version 15)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand oder Gesamtbreite <" (rtos (getvar "OFFSETDIST") 2) ">: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers (getvar "OFFSETDIST")))
(if (/= abstand_2s_vers "Gesamtbreite")
(setq abstand_2s_vers_am699 abstand_2s_vers))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
(setq reihenfolge "aa1")
(if (= abstand_2s_vers "Gesamtbreite")
(progn
(if (> version 14)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite angeben <" (rtos (* (getvar "OFFSETDIST") 2.0) 2) ">: ")))))
(if (< version 15)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite <" (rtos (* (getvar "OFFSETDIST") 2.0) 2) ">: ")))))
(if (= gesamtbreite_2s_vers nil)
(setq gesamtbreite_2s_vers (* (getvar "OFFSETDIST") 2.0)))
(setq abstand_2s_vers (/ gesamtbreite_2s_vers 2.0))
(setq abstand_2s_vers_am699 abstand_2s_vers)
(setq reihenfolge "ag1")
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite"))))))


;Unterprogramm ABSTAND_2S_VERS_AUFRUFX_R15

(defun abstand_2s_vers_aufrufx_r15 ()
(if (> version 14)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand angeben oder [Gesamtbreite] <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (< version 15)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand oder Gesamtbreite <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
(if (= abstand_2s_vers "Gesamtbreite")
(progn
(if (> version 14)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite angeben <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (< version 15)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (/= gesamtbreite_2s_vers nil)
(setq abstand_2s_vers (/ gesamtbreite_2s_vers 2.0)))
(if (= gesamtbreite_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite")
(setq reihenfolge "ag1")
))
(setq abstand_2s_vers_am699 abstand_2s_vers))


;Unterprogramm GESAMTBREITE_2S_VERS_AUFRUFX_R15

(defun gesamtbreite_2s_vers_aufrufx_r15 ()
(if (> version 14)
(progn
(initget 6 "Abstand")
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite angeben oder [Abstand] <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (< version 15)
(progn
(initget 6 "Abstand")
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite oder Abstand <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (and (/= gesamtbreite_2s_vers nil) (/= gesamtbreite_2s_vers "Abstand"))
(setq abstand_2s_vers (/ gesamtbreite_2s_vers 2.0)))
(if (= gesamtbreite_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite")
(if (= gesamtbreite_2s_vers "Abstand")
(progn
(if (> version 14)
(progn
(initget 6)
(setq abstand_2s_vers (getdist (strcat "\nAbstand angeben <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (< version 15)
(progn
(initget 6)
(setq abstand_2s_vers (getdist (strcat "\nAbstand <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
))
(setq abstand_2s_vers_am699 abstand_2s_vers))


;Unterprogramm JA_NEIN_AUFRUF1

(defun ja_nein_aufruf1 ()
(if (> version 14)
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nQuellobjekt lschen? [Ja/Nein] <N>: "))))
(if (< version 15)
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nAltes Objekt lschen? <N>: "))))
(if (= option_2 nil)
(setq option_2 "Nein"))
(setq option_2_2s_vers_699 option_2))


;Unterprogramm JA_NEIN_AUFRUFX

(defun ja_nein_aufrufx ()
(if (> version 14)
(progn
(if (= option_2_2s_vers_699 "Ja")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nQuellobjekt lschen? [Ja/Nein] <J>: "))))))
(if (< version 15)
(progn
(if (= option_2_2s_vers_699 "Ja")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nAltes Objekt lschen? <J>: "))))))
(if (> version 14)
(progn
(if (= option_2_2s_vers_699 "Nein")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nQuellobjekt lschen? [Ja/Nein] <N>: "))))))
(if (< version 15)
(progn
(if (= option_2_2s_vers_699 "Nein")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nAltes Objekt lschen? <N>: "))))))
(if (= option_2 nil)
(setq option_2 option_2_2s_vers_699))
(setq option_2_2s_vers_699 option_2))


;Unterprogramm OBJEKTWAHL_2S_VERS_AM699

(defun objektwahl_2s_vers_am699 ()
(if (> version 14)
(progn
(initget " ")
(setq kante (entsel "\nZu versetzendes Objekt whlen oder <exit>: "))))
(if (< version 15)
(progn
(initget " ")
(setq kante (entsel "\nObjekt whlen, das versetzt werden soll: ")))))


;Unterprogramm TYPPRUEFUNG_2S_VERS_AM699

(defun typpruefung_2s_vers_am699 ()
(setq et_kante (cdr (assoc 0 (entget (car kante)))))
(if (= et_kante "POLYLINE")
(progn
(setq liste_100 (apply 'append
(mapcar
'(lambda (y)
(if (= (car y) 100)
(list (cdr y)))) (entget (car kante)))))
(if (= (cadr liste_100) "AcDb3dPolyline")
(setq et_kante "3DPOLYLINE")))))


;Unterprogramm WARNMELDUNG_2S_VERS_AM699

(defun warnmeldung_2s_vers_am699 ()
(princ "\nDieses Objekt kann nicht versetzt werden. "))


;Unterprogramm VERSETZEN_2S_VERS_AM699

(defun versetzen_2s_vers_am699 ()
(setq entityliste (entget (car kante)))
(setq objekttyp (cdr (assoc 0 entityliste)))
(if (= objekttyp "LINE")
(punktberechnung_linie))
(if (= objekttyp "CIRCLE")
(punktberechnung_kreis))
(if (= objekttyp "ARC")
(punktberechnung_bogen))
(if (= objekttyp "RAY")
(punktberechnung_strahl_klinie))
(if (= objekttyp "XLINE")
(punktberechnung_strahl_klinie))
(if (= objekttyp "ELLIPSE")
(punktberechnung_ellipse))
(if (= objekttyp "LWPOLYLINE")
(punktberechnung_lwpolylinie_spline))
(if (= objekttyp "SPLINE")
(punktberechnung_lwpolylinie_spline))
(if (= objekttyp "POLYLINE")
(punktberechnung_polylinie))
(setvar "OSMODE" 0)
(setvar "BLIPMODE" 0)
(command "._offset" "" kante p1 "")
(command "._offset" "" kante p2 "")
(setq weiterversetzen_2s_vers_am699 "ja")
(if (= option_2_2s_vers_699 "Ja")
(command "._erase" kante "")))


;Unterprogramm OBJEKTWAHL_2S_VERS_AM699_MTP

(defun objektwahl_2s_vers_am699_mtp ()
(objektwahl_2s_vers_am699)
(while (= kante nil)
(objektwahl_2s_vers_am699))
(if (and (/= kante nil) (/= kante ""))
(typpruefung_2s_vers_am699)))


;Unterprogramm HAUPTOBJEKTWAHL_2S_VERS_AM699

(defun hauptobjektwahl_2s_vers_am699 ()
(setq weiterversetzen_2s_vers_am699 nil)
(objektwahl_2s_vers_am699)
(while (= kante nil)
(objektwahl_2s_vers_am699))
(if (and (/= kante nil) (/= kante ""))
(typpruefung_2s_vers_am699))
(while (and (/= et_kante "ARC") (/= et_kante "CIRCLE") (/= et_kante "ELLIPSE") (/= et_kante "LINE") (/= et_kante "LWPOLYLINE") (/= et_kante "POLYLINE") (/= et_kante "RAY") (/= et_kante "SPLINE") (/= et_kante "XLINE") (/= kante ""))
(progn
(warnmeldung_2s_vers_am699)
(objektwahl_2s_vers_am699_mtp))))


;Hauptprogramm 2S_VERS

(defun c:2s_vers ( / error_akt version cmdecho_akt dimzin_akt osmode_akt offsetdist_akt blipmode_akt startpunkt endpunkt winkel p1 p2 startwinkel_wks zentrum_wks zentrum radius richtungsvektor mitte hauptachse punktliste objektname subentity_1 subentity_2 vertex1 vertex2 abstand_2s_vers gesamtbreite_2s_vers reihenfolge kante et_kante entityliste objekttyp option_2 liste_100)
(setq error_akt *error*)
(setq *error* *2s_vers_error*)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(setq dimzin_akt (getvar "DIMZIN"))
(setq osmode_akt (getvar "OSMODE"))
(setq offsetdist_akt (getvar "OFFSETDIST"))
(setq blipmode_akt (getvar "BLIPMODE"))
(setvar "CMDECHO" 0)
(setvar "DIMZIN" 0)
(if (= abstand_2s_vers_am699 nil)
(progn
(abstand_2s_vers_aufruf1_r15)
(ja_nein_aufruf1)))
(if (and (/= abstand_2s_vers_am699 nil) (= abstand_oder_gesamtbreite_2s_vers_am699 "Abstand") (/= reihenfolge "aa1"))
(progn
(abstand_2s_vers_aufrufx_r15)
(ja_nein_aufrufx)))
(if (and (/= abstand_2s_vers_am699 nil) (= abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite") (/= reihenfolge "ag1"))
(progn
(gesamtbreite_2s_vers_aufrufx_r15)
(ja_nein_aufrufx)))
(setvar "OFFSETDIST" abstand_2s_vers)
(hauptobjektwahl_2s_vers_am699)
(if (/= kante "")
(versetzen_2s_vers_am699))
(while (= weiterversetzen_2s_vers_am699 "ja")
(progn
(hauptobjektwahl_2s_vers_am699)
(if (/= kante "")
(versetzen_2s_vers_am699))))
(setvar "CMDECHO" cmdecho_akt)
(setvar "DIMZIN" dimzin_akt)
(setvar "OSMODE" osmode_akt)
(setvar "OFFSETDIST" offsetdist_akt)
(setvar "BLIPMODE" blipmode_akt)
(setq *error* error_akt)
(princ))
(setq version_2s_vers_acadmag_6_99 (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_2s_vers_acadmag_6_99 13) (> version_2s_vers_acadmag_6_99 15))
(princ "\nAutoLISP-Tool 2S_VERS geladen."))
(if (= version_2s_vers_acadmag_6_99 13)
(princ "\nAutoLISP-Tool 2S_VERS fr AutoCAD 13 geladen."))
(if (= version_2s_vers_acadmag_6_99 14)
(princ "\nAutoLISP-Tool 2S_VERS fr AutoCAD 14 geladen."))
(if (= version_2s_vers_acadmag_6_99 15)
(princ "\nAutoLISP-Tool 2S_VERS fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit 2S_VERS auf. ")
(setq version_2s_vers_acadmag_6_99 nil)
(princ)
(terpri)
