;2S_VERS.LSP

;Mit dem AutoCAD-Standardbefehl VERSETZ werden neue Objekte erstellt, die quasi Kopien ausgewhlter Objekte sind und in einem bestimmten Abstand parallel zu diesen liegen. Dafr werden Sie jeweils aufgefordert am Bildschirm zu zeigen, auf welcher  Seite die neuen Elemente plaziert werden sollen. Bei der tglichen Konstruktionsarbeit kommt es aber immer wieder vor, dass die Objekte nach beiden Seiten hin versetzt werden mssen. Hierfr sind nun schon vier Klicks ntig, nmlich das Picken des zu versetzenden Objekts, das Zeigen der Seite, auf die versetzt werden soll und dann beide Schritte nochmals fr die andere Seite. Schn wre jetzt wenn das alles mit einem Klick machbar wre. Genau diese Mglichkeit bietet das AutoLISP-Tool 2S_VERS.LSP. Nachdem Sie das Tool mit dem Befehl APPLOAD geladen und anschlieend den Befehl durch die Eingabe von 2S_VERS aufgerufen haben, knnen Sie whlen zwischen den Optionen "Abstand" und "Gesamtbreite". Geben Sie einen Abstand ein, entspricht dies der Entfernung zwischen dem alten Objekt und dem neuen, so wie Sie es vom AutoCAD-Befehl VERSETZ kennen. Whlen Sie die Option "Gesamtbreite" legen Sie hierber den Abstand zwischen den beiden neuen Objekten fest, sie entspricht also dem doppelten Wert der Option "Abstand". Dies hat den Vorteil, dass Sie sich die Berechnung des Abstands ersparen knnen, wenn Sie beispielsweise entlang einer Mittelachse einen Weg mit einer bestimmten Breite zeichnen wollen. Anschlieend haben Sie noch die Mglichkeit zu bestimmen, ob das alte Objekt gelscht werden oder erhalten bleiben soll. Haben Sie diese Eingaben gettigt, knnen Sie mit dem Versetzen beginnen,  der Befehl bleibt dabei solange im Wiederholmodus, bis Sie ihn mit RETURN oder ESCAPE abbrechen. Fr alle Optionsanfragen werden Vorgabewerte angeboten, die Sie mit der Return-Taste besttigen und damit auswhlen knnen. Diese Vorgaben werden nach jeder Programmausfhrung aktualisiert und entsprechen immer den gewhlten Optionen des letzten Programmaufrufs. Beim ersten Programmaufruf werden die Optionen "Abstand", als Wert fr den Abstand der Wert der Systemvariablen OFFSETDIST des AutoCAD-Befehls VERSETZ, sowie die Option "Nein" fr das Lschen des alten Objekts verwendet. Danach werden die neuen oder auch bernommenen Werte in globalen Variablen gespeichert und bei weiteren Programmausfhrungen als Vorgabewerte angeboten. Dadurch ist immer ein zgiges Arbeiten gewhrleistet, da sich das Programm an den Gewohnheiten des Anwenders orientiert. Den Wert fr den Abstand oder die Gesamtbreite, je nach gewhlter Option, knnen Sie als numerischen Wert ber die Tastatur eingeben oder durch die Wahl zweier Punkte am Bildschirm festlegen. Hierfr wird vom Programm die AutoLISP-Funktion GETDIST verwendet. Versetzt werden knnen mit dem Tool Elemente des Objekttyps Linie, 2D-Polylinie, Bogen, Kreis, Konstruktionslinie, Strahl und Spline. Haben Sie ein anderes Objekt gewhlt erscheint in der Befehlszeile die Meldung "Dieses Objekt kann nicht versetzt werden." und Sie werden erneut zur Objektwahl aufgefordert.

;Befehlsaufruf: 2S_VERS

;Programmiert von Gerhard Rampf am 24.10.1999
;Modifiziert von Gerhard Rampf am 06.03.2000


;Programmgebundene Fehlerroutine *2S_VERS_ERROR*

(defun *2s_vers_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= offsetdist_akt nil)
(setvar "OFFSETDIST" offsetdist_akt))
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= dimzin_akt nil)
(setvar "DIMZIN" dimzin_akt))
(if (/= osmode_akt nil)
(setvar "OSMODE" osmode_akt))
(if (/= blipmode_akt nil)
(setvar "BLIPMODE" blipmode_akt))
(setq error_akt nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq dimzin_akt nil)
(setq osmode_akt nil)
(setq offsetdist_akt nil)
(setq blipmode_akt nil)
(setq startpunkt nil)
(setq endpunkt nil)
(setq winkel nil)
(setq p1 nil)
(setq p2 nil)
(setq startwinkel_wks nil)
(setq zentrum_wks nil)
(setq zentrum nil)
(setq radius nil)
(setq richtungsvektor nil)
(setq mitte nil)
(setq hauptachse nil)
(setq punktliste nil)
(setq objektname nil)
(setq subentity_1 nil)
(setq subentity_2 nil)
(setq vertex1 nil)
(setq vertex2 nil)
(setq abstand_2s_vers nil)
(setq gesamtbreite_2s_vers nil)
(setq reihenfolge nil)
(setq kante nil)
(setq et_kante nil)
(setq entityliste nil)
(setq objekttyp nil)
(setq option_2 nil)
(setq liste_100 nil)
(setq version_2s_vers_am_6_99 nil)
(princ))


;Unterprogramm PUNKTBERECHNUNG_LINIE

(defun punktberechnung_linie ()
(setq startpunkt (trans (cdr (assoc 10 entityliste)) 0 1))
(setq endpunkt (trans (cdr (assoc 11 entityliste)) 0 1))
(setq winkel (angle startpunkt endpunkt))
(setq p1 (polar startpunkt (+ winkel (/ pi 2.0)) 0.0001))
(setq p2 (polar startpunkt (+ winkel (* pi 1.5)) 0.0001)))


;Unterprogramm PUNKTBERECHNUNG_KREIS

(defun punktberechnung_kreis ()
(setq zentrum (trans (cdr (assoc 10 entityliste)) 0 1))
(setq radius (cdr (assoc 40 entityliste)))
(setq p1 zentrum)
(setq p2 (polar zentrum 0 (+ radius 0.0001))))


;Unterprogramm PUNKTBERECHNUNG_BOGEN

(defun punktberechnung_bogen ()
(setq startwinkel_wks (cdr (assoc 50 entityliste)))
(setq zentrum_wks (cdr (assoc 10 entityliste)))
(setq zentrum (trans (cdr (assoc 10 entityliste)) 0 1))
(setq radius (cdr (assoc 40 entityliste)))
(setq p1 zentrum)
(setq p2 (trans (polar zentrum_wks startwinkel_wks (+ radius 0.0001)) 0 1)))


;Unterprogramm PUNKTBERECHNUNG_STRAHL_KLINIE

(defun punktberechnung_strahl_klinie ()
(setq startpunkt (trans (cdr (assoc 10 entityliste)) 0 1))
(setq richtungsvektor (trans (cdr (assoc 11 entityliste)) 0 1))
(setq winkel (angle '(0.0 0.0 0.0) richtungsvektor))
(setq p1 (polar startpunkt (+ winkel (/ pi 2.0)) 0.0001))
(setq p2 (polar startpunkt (+ winkel (* pi 1.5)) 0.0001)))


;Unterprogramm PUNKTBERECHNUNG_ELLIPSE

(defun punktberechnung_ellipse ()
(setq mitte (trans (cdr (assoc 10 entityliste)) 0 1))
(setq hauptachse (abs (car (cdr (assoc 11 entityliste)))))
(setq p1 mitte)
(setq p2 (polar mitte 0 (+ hauptachse 0.0001))))


;Unterprogramm PUNKTBERECHNUNG_LWPOLYLINIE_SPLINE

(defun punktberechnung_lwpolylinie_spline ()
(setq punktliste (apply 'append
(mapcar
'(lambda (x)
(if (= 10 (car x))
(list (cdr x)))) entityliste)))
(setq startpunkt (car punktliste))
(setq endpunkt (cadr punktliste))
(setq winkel (angle startpunkt endpunkt))
(setq p1 (trans (polar startpunkt (+ winkel (/ pi 2.0)) 0.0001) 0 1))
(setq p2 (trans (polar startpunkt (+ winkel (* pi 1.5)) 0.0001) 0 1)))


;Unterprogramm PUNKTBERECHNUNG_POLYLINIE

(defun punktberechnung_polylinie ()
(setq objektname (car kante))
(setq subentity_1 (entnext objektname))
(setq subentity_2 (entnext subentity_1))
(setq vertex1 (cdr (assoc 10 (entget subentity_1))))
(setq vertex2 (cdr (assoc 10 (entget subentity_2))))
(setq winkel (angle vertex1 vertex2))
(setq p1 (trans (polar vertex1 (+ winkel (/ pi 2.0)) 0.0001) 0 1))
(setq p2 (trans (polar vertex1 (+ winkel (* pi 1.5)) 0.0001) 0 1)))


;Unterprogramm ABSTAND_2S_VERS_AUFRUF1_R15

(defun abstand_2s_vers_aufruf1_r15 ()
(if (<= (getvar "OFFSETDIST") 0)
(progn
(if (> version 14)
(progn
(initget 6 "Gesamtbreite")
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nAbstand angeben oder [Gesamtbreite] <1.00000000>: ")))))
(if (< version 15)
(progn
(initget 6 "Gesamtbreite")
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nAbstand oder Gesamtbreite <1.00000000>: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers 1.0))
(if (/= abstand_2s_vers "Gesamtbreite")
(setq abstand_2s_vers_am699 abstand_2s_vers))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
(setq reihenfolge "aa1")
(if (= abstand_2s_vers "Gesamtbreite")
(progn
(if (> version 14)
(progn
(initget 6)
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nGesamtbreite angeben <1.00000000>: ")))))
(if (< version 15)
(progn
(initget 6)
(if (= (getvar "LUPREC") 0)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1>: ")))
(if (= (getvar "LUPREC") 1)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.0>: ")))
(if (= (getvar "LUPREC") 2)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.00>: ")))
(if (= (getvar "LUPREC") 3)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.000>: ")))
(if (= (getvar "LUPREC") 4)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.0000>: ")))
(if (= (getvar "LUPREC") 5)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.00000>: ")))
(if (= (getvar "LUPREC") 6)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.000000>: ")))
(if (= (getvar "LUPREC") 7)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.0000000>: ")))
(if (= (getvar "LUPREC") 8)
(setq abstand_2s_vers (getdist "\nGesamtbreite <1.00000000>: ")))))
(if (/= abstand_2s_vers nil)
(setq abstand_2s_vers (/ abstand_2s_vers 2.0)))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers 0.5))
(setq abstand_2s_vers_am699 abstand_2s_vers)
(setq reihenfolge "ag1")
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite")))))
(if (> (getvar "OFFSETDIST") 0)
(progn
(if (> version 14)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand angeben oder [Gesamtbreite] <" (rtos (getvar "OFFSETDIST") 2) ">: ")))))
(if (< version 15)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand oder Gesamtbreite <" (rtos (getvar "OFFSETDIST") 2) ">: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers (getvar "OFFSETDIST")))
(if (/= abstand_2s_vers "Gesamtbreite")
(setq abstand_2s_vers_am699 abstand_2s_vers))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
(setq reihenfolge "aa1")
(if (= abstand_2s_vers "Gesamtbreite")
(progn
(if (> version 14)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite angeben <" (rtos (* (getvar "OFFSETDIST") 2.0) 2) ">: ")))))
(if (< version 15)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite <" (rtos (* (getvar "OFFSETDIST") 2.0) 2) ">: ")))))
(if (= gesamtbreite_2s_vers nil)
(setq gesamtbreite_2s_vers (* (getvar "OFFSETDIST") 2.0)))
(setq abstand_2s_vers (/ gesamtbreite_2s_vers 2.0))
(setq abstand_2s_vers_am699 abstand_2s_vers)
(setq reihenfolge "ag1")
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite"))))))


;Unterprogramm ABSTAND_2S_VERS_AUFRUFX_R15

(defun abstand_2s_vers_aufrufx_r15 ()
(if (> version 14)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand angeben oder [Gesamtbreite] <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (< version 15)
(progn
(initget 6 "Gesamtbreite")
(setq abstand_2s_vers (getdist (strcat "\nAbstand oder Gesamtbreite <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
(if (= abstand_2s_vers "Gesamtbreite")
(progn
(if (> version 14)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite angeben <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (< version 15)
(progn
(initget 6)
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (/= gesamtbreite_2s_vers nil)
(setq abstand_2s_vers (/ gesamtbreite_2s_vers 2.0)))
(if (= gesamtbreite_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite")
(setq reihenfolge "ag1")
))
(setq abstand_2s_vers_am699 abstand_2s_vers))


;Unterprogramm GESAMTBREITE_2S_VERS_AUFRUFX_R15

(defun gesamtbreite_2s_vers_aufrufx_r15 ()
(if (> version 14)
(progn
(initget 6 "Abstand")
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite angeben oder [Abstand] <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (< version 15)
(progn
(initget 6 "Abstand")
(setq gesamtbreite_2s_vers (getdist (strcat "\nGesamtbreite oder Abstand <" (rtos (* abstand_2s_vers_am699 2.0) 2) ">: ")))))
(if (and (/= gesamtbreite_2s_vers nil) (/= gesamtbreite_2s_vers "Abstand"))
(setq abstand_2s_vers (/ gesamtbreite_2s_vers 2.0)))
(if (= gesamtbreite_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite")
(if (= gesamtbreite_2s_vers "Abstand")
(progn
(if (> version 14)
(progn
(initget 6)
(setq abstand_2s_vers (getdist (strcat "\nAbstand angeben <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (< version 15)
(progn
(initget 6)
(setq abstand_2s_vers (getdist (strcat "\nAbstand <" (rtos abstand_2s_vers_am699 2) ">: ")))))
(if (= abstand_2s_vers nil)
(setq abstand_2s_vers abstand_2s_vers_am699))
(setq abstand_oder_gesamtbreite_2s_vers_am699 "Abstand")
))
(setq abstand_2s_vers_am699 abstand_2s_vers))


;Unterprogramm JA_NEIN_AUFRUF1

(defun ja_nein_aufruf1 ()
(if (> version 14)
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nQuellobjekt lschen? [Ja/Nein] <N>: "))))
(if (< version 15)
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nAltes Objekt lschen? <N>: "))))
(if (= option_2 nil)
(setq option_2 "Nein"))
(setq option_2_2s_vers_699 option_2))


;Unterprogramm JA_NEIN_AUFRUFX

(defun ja_nein_aufrufx ()
(if (> version 14)
(progn
(if (= option_2_2s_vers_699 "Ja")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nQuellobjekt lschen? [Ja/Nein] <J>: "))))))
(if (< version 15)
(progn
(if (= option_2_2s_vers_699 "Ja")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nAltes Objekt lschen? <J>: "))))))
(if (> version 14)
(progn
(if (= option_2_2s_vers_699 "Nein")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nQuellobjekt lschen? [Ja/Nein] <N>: "))))))
(if (< version 15)
(progn
(if (= option_2_2s_vers_699 "Nein")
(progn
(initget "Ja Nein")
(setq option_2 (getkword "\nAltes Objekt lschen? <N>: "))))))
(if (= option_2 nil)
(setq option_2 option_2_2s_vers_699))
(setq option_2_2s_vers_699 option_2))


;Unterprogramm OBJEKTWAHL_2S_VERS_AM699

(defun objektwahl_2s_vers_am699 ()
(if (> version 14)
(progn
(initget " ")
(setq kante (entsel "\nZu versetzendes Objekt whlen oder <exit>: "))))
(if (< version 15)
(progn
(initget " ")
(setq kante (entsel "\nObjekt whlen, das versetzt werden soll: ")))))


;Unterprogramm TYPPRUEFUNG_2S_VERS_AM699

(defun typpruefung_2s_vers_am699 ()
(setq et_kante (cdr (assoc 0 (entget (car kante)))))
(if (= et_kante "POLYLINE")
(progn
(setq liste_100 (apply 'append
(mapcar
'(lambda (y)
(if (= (car y) 100)
(list (cdr y)))) (entget (car kante)))))
(if (= (cadr liste_100) "AcDb3dPolyline")
(setq et_kante "3DPOLYLINE")))))


;Unterprogramm WARNMELDUNG_2S_VERS_AM699

(defun warnmeldung_2s_vers_am699 ()
(princ "\nDieses Objekt kann nicht versetzt werden. "))


;Unterprogramm VERSETZEN_2S_VERS_AM699

(defun versetzen_2s_vers_am699 ()
(setq entityliste (entget (car kante)))
(setq objekttyp (cdr (assoc 0 entityliste)))
(if (= objekttyp "LINE")
(punktberechnung_linie))
(if (= objekttyp "CIRCLE")
(punktberechnung_kreis))
(if (= objekttyp "ARC")
(punktberechnung_bogen))
(if (= objekttyp "RAY")
(punktberechnung_strahl_klinie))
(if (= objekttyp "XLINE")
(punktberechnung_strahl_klinie))
(if (= objekttyp "ELLIPSE")
(punktberechnung_ellipse))
(if (= objekttyp "LWPOLYLINE")
(punktberechnung_lwpolylinie_spline))
(if (= objekttyp "SPLINE")
(punktberechnung_lwpolylinie_spline))
(if (= objekttyp "POLYLINE")
(punktberechnung_polylinie))
(setvar "OSMODE" 0)
(setvar "BLIPMODE" 0)
(command "._offset" "" kante p1 "")
(command "._offset" "" kante p2 "")
(setq weiterversetzen_2s_vers_am699 "ja")
(if (= option_2_2s_vers_699 "Ja")
(command "._erase" kante "")))


;Unterprogramm OBJEKTWAHL_2S_VERS_AM699_MTP

(defun objektwahl_2s_vers_am699_mtp ()
(objektwahl_2s_vers_am699)
(while (= kante nil)
(objektwahl_2s_vers_am699))
(if (and (/= kante nil) (/= kante ""))
(typpruefung_2s_vers_am699)))


;Unterprogramm HAUPTOBJEKTWAHL_2S_VERS_AM699

(defun hauptobjektwahl_2s_vers_am699 ()
(setq weiterversetzen_2s_vers_am699 nil)
(objektwahl_2s_vers_am699)
(while (= kante nil)
(objektwahl_2s_vers_am699))
(if (and (/= kante nil) (/= kante ""))
(typpruefung_2s_vers_am699))
(while (and (/= et_kante "ARC") (/= et_kante "CIRCLE") (/= et_kante "ELLIPSE") (/= et_kante "LINE") (/= et_kante "LWPOLYLINE") (/= et_kante "POLYLINE") (/= et_kante "RAY") (/= et_kante "SPLINE") (/= et_kante "XLINE") (/= kante ""))
(progn
(warnmeldung_2s_vers_am699)
(objektwahl_2s_vers_am699_mtp))))


;Hauptprogramm 2S_VERS

(defun c:2s_vers ( / error_akt version cmdecho_akt dimzin_akt osmode_akt offsetdist_akt blipmode_akt startpunkt endpunkt winkel p1 p2 startwinkel_wks zentrum_wks zentrum radius richtungsvektor mitte hauptachse punktliste objektname subentity_1 subentity_2 vertex1 vertex2 abstand_2s_vers gesamtbreite_2s_vers reihenfolge kante et_kante entityliste objekttyp option_2 liste_100)
(setq error_akt *error*)
(setq *error* *2s_vers_error*)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(setq dimzin_akt (getvar "DIMZIN"))
(setq osmode_akt (getvar "OSMODE"))
(setq offsetdist_akt (getvar "OFFSETDIST"))
(setq blipmode_akt (getvar "BLIPMODE"))
(setvar "CMDECHO" 0)
(setvar "DIMZIN" 0)
(if (= abstand_2s_vers_am699 nil)
(progn
(abstand_2s_vers_aufruf1_r15)
(ja_nein_aufruf1)))
(if (and (/= abstand_2s_vers_am699 nil) (= abstand_oder_gesamtbreite_2s_vers_am699 "Abstand") (/= reihenfolge "aa1"))
(progn
(abstand_2s_vers_aufrufx_r15)
(ja_nein_aufrufx)))
(if (and (/= abstand_2s_vers_am699 nil) (= abstand_oder_gesamtbreite_2s_vers_am699 "Gesamtbreite") (/= reihenfolge "ag1"))
(progn
(gesamtbreite_2s_vers_aufrufx_r15)
(ja_nein_aufrufx)))
(setvar "OFFSETDIST" abstand_2s_vers)
(hauptobjektwahl_2s_vers_am699)
(if (/= kante "")
(versetzen_2s_vers_am699))
(while (= weiterversetzen_2s_vers_am699 "ja")
(progn
(hauptobjektwahl_2s_vers_am699)
(if (/= kante "")
(versetzen_2s_vers_am699))))
(setvar "CMDECHO" cmdecho_akt)
(setvar "DIMZIN" dimzin_akt)
(setvar "OSMODE" osmode_akt)
(setvar "OFFSETDIST" offsetdist_akt)
(setvar "BLIPMODE" blipmode_akt)
(setq *error* error_akt)
(princ))
(setq version_2s_vers_acadmag_6_99 (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_2s_vers_acadmag_6_99 13) (> version_2s_vers_acadmag_6_99 15))
(princ "\nAutoLISP-Tool 2S_VERS geladen."))
(if (= version_2s_vers_acadmag_6_99 13)
(princ "\nAutoLISP-Tool 2S_VERS fr AutoCAD 13 geladen."))
(if (= version_2s_vers_acadmag_6_99 14)
(princ "\nAutoLISP-Tool 2S_VERS fr AutoCAD 14 geladen."))
(if (= version_2s_vers_acadmag_6_99 15)
(princ "\nAutoLISP-Tool 2S_VERS fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit 2S_VERS auf. ")
(setq version_2s_vers_acadmag_6_99 nil)
(princ)
(terpri)


;**********************************************************************

;ALLE_EIN.LSP

;Programmiert von Gerhard RAmpf am 02.04.2000

(defun *alle_ein_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(setq auswahlsatz_alle_ein nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq entity_name nil)
(setq entity_list nil)
(setq entity_list_neu nil)
(setq error_akt nil)
(setq version_alle_ein nil)
(princ))
(defun c:alle_ein ( / auswahlsatz_alle_ein entity_anzahl entity_nummer entity_name entity_list entity_list_neu version_alle_ein)
(setq error_akt *error*)
(setq *error* *alle_ein_error*)
(setq auswahlsatz_alle_ein (ssget "X" (list (cons 60 1))))
(if (= auswahlsatz_alle_ein nil)
(princ "\nAlle Objekte sind sichtbar geschaltet. "))
(if (/= auswahlsatz_alle_ein nil)
(progn
(setq entity_anzahl (sslength auswahlsatz_alle_ein))
(setq entity_nummer (- 0.0 1))
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_alle_ein entity_nummer))
(setq entity_list (entget entity_name))
(setq entity_list_neu (subst (cons 60 0) (assoc 60 entity_list) entity_list))
(entmod entity_list_neu))
(terpri)
(princ entity_anzahl)
(if (= entity_anzahl 1)
(princ " Objekt wurde sichtbar geschaltet."))
(if (> entity_anzahl 1)
(princ " Objekte wurden sichtbar geschaltet."))))
(setq auswahlsatz_alle_ein nil)
(setq *error* error_akt)
(princ))
(setq version_alle_ein (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_alle_ein 13) (> version_alle_ein 15))
(princ "\nAutoLISP-Tool ALLE_EIN geladen."))
(if (= version_alle_ein 13)
(princ "\nAutoLISP-Tool ALLE_EIN fr AutoCAD 13 geladen."))
(if (= version_alle_ein 14)
(princ "\nAutoLISP-Tool ALLE_EIN fr AutoCAD 14 geladen."))
(if (= version_alle_ein 15)
(princ "\nAutoLISP-Tool ALLE_EIN fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit ALLE_EIN auf. ")
(setq version_alle_ein nil)
(princ)
(terpri)

;*****************************************************************************

;AWS_AUS.LSP

;Programmiert von Gerhard Rampf am 02.04.2000

(defun *aws_aus_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(setq error_akt nil)
(setq auswahlsatz_aws_aus_300 nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq ticker nil)
(setq entity_name nil)
(setq entity_list nil)
(setq code60 nil)
(setq entity_list_neu nil)
(setq version_aws_aus nil)
(princ))
(defun c:aws_aus ( / error_akt auswahlsatz_aws_aus_300 entity_anzahl entity_nummer ticker entity_name entity_list code60 entity_list_neu version_aws_aus)
(setq error_akt *error*)
(setq *error* *aws_aus_error*)
(setq auswahlsatz_aws_aus_300 (ssget))
(if (= auswahlsatz_aws_aus_300 nil)
(princ "\nKeine Objekte gefunden. "))
(if (/= auswahlsatz_aws_aus_300 nil)
(progn
(setq entity_anzahl (sslength auswahlsatz_aws_aus_300))
(setq entity_nummer (- 0.0 1))
(setq ticker 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_aws_aus_300 entity_nummer))
(setq entity_list (entget entity_name))
(setq code60 (cdr (assoc 60 entity_list)))
(if (or (= code60 0) (= code60 nil))
(progn
(setq entity_list_neu (append entity_list (list (cons 60 1))))
(setq ticker (+ ticker 1))
(entmod entity_list_neu))))
(terpri)
(princ ticker)
(if (or (= ticker 0) (> ticker 1))
(princ " Objekte wurden unsichtbar geschaltet. "))
(if (= ticker 1)
(princ " Objekt wurde unsichtbar geschaltet. "))
(setq auswahlsatz_aws_aus_300 nil)))
(setq *error* error_akt)
(princ))
(setq version_aws_aus (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_aws_aus 13) (> version_aws_aus 15))
(princ "\nAutoLISP-Tool AWS_AUS geladen."))
(if (= version_aws_aus 13)
(princ "\nAutoLISP-Tool AWS_AUS fr AutoCAD 13 geladen."))
(if (= version_aws_aus 14)
(princ "\nAutoLISP-Tool AWS_AUS fr AutoCAD 14 geladen."))
(if (= version_aws_aus 15)
(princ "\nAutoLISP-Tool AWS_AUS fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit AWS_AUS auf. ")
(setq version_aws_aus nil)
(princ)
(terpri)

;*************************************************************************

;AWS_ISO.LSP

;Programmiert von Gerhard Rampf am 01.04.2000

(defun *aws_iso_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= isolierter_auswahlsatz_aws_iso_300 nil)
(progn
(setq iso_elementanzahl (sslength isolierter_auswahlsatz_aws_iso_300))
(setq iso_element (- 0 1))
(while (and (= (getvar "HIGHLIGHT") 1) (< iso_elementanzahl 200) (< iso_element iso_elementanzahl) (/= iso_element (- iso_elementanzahl 1)))
(setq iso_element (+ iso_element 1))
(setq iso_elementname (ssname isolierter_auswahlsatz_aws_iso_300 iso_element))
(redraw iso_elementname 4))))
(setq erster_layer nil)
(setq layername nil)
(setq eigenschaftenliste nil)
(setq flag_70 nil)
(setq naechster_layer nil)
(setq layername_n nil)
(setq isolierter_auswahlsatz_aws_iso_300 nil)
(setq iso_elementanzahl nil)
(setq iso_element nil)
(setq iso_elementname nil)
(setq auswahlsatz_aws_iso_300_g nil)
(setq af_mittelpunkt nil)
(setq af_hoehe nil)
(setq aufloesung nil)
(setq pixel_breit nil)
(setq pixel_hoch nil)
(setq af_breite nil)
(setq p1 nil)
(setq p2 nil)
(setq auswahlsatz_aws_iso_300_a nil)
(setq option_aws_iso nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq zaehler_aws_iso nil)
(setq entity_name nil)
(setq entity_list nil)
(setq entity_list_neu nil)
(setq entity_anzahl_isoliert nil)
(setq error_akt nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq version_aws_iso nil)
(princ))
(defun gesperrte_layer_test_aws_iso_300 ()
(setq erster_layer (tblnext "LAYER" T))
(setq layername (cdr (assoc 2 erster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(if (and (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(setq naechster_layer (tblnext "LAYER")))
(while (and (/= naechster_layer nil) (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(progn
(setq layername_n (cdr (assoc 2 naechster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername_n))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(setq naechster_layer (tblnext "LAYER")))))
(defun objektwahl_aws_iso_300 ()
(setq isolierter_auswahlsatz_aws_iso_300 (ssget)))
(defun ausleuchten_aws_iso_300 ()
(setq iso_elementanzahl (sslength isolierter_auswahlsatz_aws_iso_300))
(setq iso_element (- 0 1))
(while (and (= (getvar "HIGHLIGHT") 1) (< iso_elementanzahl 200) (< iso_element iso_elementanzahl) (/= iso_element (- iso_elementanzahl 1)))
(setq iso_element (+ iso_element 1))
(setq iso_elementname (ssname isolierter_auswahlsatz_aws_iso_300 iso_element))
(redraw iso_elementname 3)))
(defun r_ausleuchten_aws_iso_300 ()
(setq iso_elementanzahl (sslength isolierter_auswahlsatz_aws_iso_300))
(setq iso_element (- 0 1))
(while (and (= (getvar "HIGHLIGHT") 1) (< iso_elementanzahl 200) (< iso_element iso_elementanzahl) (/= iso_element (- iso_elementanzahl 1)))
(setq iso_element (+ iso_element 1))
(setq iso_elementname (ssname isolierter_auswahlsatz_aws_iso_300 iso_element))
(redraw iso_elementname 4)))
(defun gesamtzeichnung_aws_iso_300 ()
(setq auswahlsatz_aws_iso_300_g (ssget "X")))
(defun ansichtsfenster_aws_iso_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq auswahlsatz_aws_iso_300_a (ssget "_C" p1 p2)))
(defun optionsermittlung_aws_iso_300 ()
(initget "Gesamtzeichnung Ansichtsfenster")
(if (or (= option_aws_iso_300 nil) (= option_aws_iso_300 "Gesamtzeichnung"))
(progn
(if (> version 14)
(setq option_aws_iso (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Gesamtzeichnung>: ")))
(if (< version 15)
(setq option_aws_iso (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Gesamtzeichnung>: ")))))
(if (= option_aws_iso_300 "Ansichtsfenster")
(progn
(if (> version 14)
(setq option_aws_iso (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Ansichtsfenster>: ")))
(if (< version 15)
(setq option_aws_iso (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Ansichtsfenster>: ")))))
(if (and (= option_aws_iso_300 nil) (= option_aws_iso nil))
(setq option_aws_iso "Gesamtzeichnung"))
(if (and (/= option_aws_iso_300 nil) (= option_aws_iso nil))
(setq option_aws_iso option_aws_iso_300))
(setq option_aws_iso_300 option_aws_iso))
(defun unsichtbarschalten_g_aws_iso_300 ()
(setq entity_anzahl (sslength auswahlsatz_aws_iso_300_g))
(setq entity_nummer (- 0.0 1))
(setq zaehler_aws_iso 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_aws_iso_300_g entity_nummer))
(setq entity_list (entget entity_name))
(if (and (/= (cdr (assoc 60 entity_list)) 1) (= (ssmemb entity_name isolierter_auswahlsatz_aws_iso_300) nil))
(progn
(setq zaehler_aws_iso (+ zaehler_aws_iso 1))
(setq entity_list_neu (append entity_list (list (cons 60 1))))
(entmod entity_list_neu)))))
(defun unsichtbarschalten_a_aws_iso_300 ()
(setq entity_anzahl (sslength auswahlsatz_aws_iso_300_a))
(setq entity_nummer (- 0.0 1))
(setq zaehler_aws_iso 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_aws_iso_300_a entity_nummer))
(setq entity_list (entget entity_name))
(if (and (/= (cdr (assoc 60 entity_list)) 1) (= (ssmemb entity_name isolierter_auswahlsatz_aws_iso_300) nil))
(progn
(setq zaehler_aws_iso (+ zaehler_aws_iso 1))
(setq entity_list_neu (append entity_list (list (cons 60 1))))
(entmod entity_list_neu)))))
(defun ergebnisanzeige_a_aws_iso_300 ()
(if (= auswahlsatz_aws_iso_300_a nil)
(princ "\n0 Objekte im Ansichtsfenster isoliert. "))
(if (/= auswahlsatz_aws_iso_300_a nil)
(progn
(setq entity_anzahl (sslength auswahlsatz_aws_iso_300_a))
(setq entity_nummer (- 0.0 1))
(setq zaehler_aws_iso 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_aws_iso_300_a entity_nummer))
(setq entity_list (entget entity_name))
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq zaehler_aws_iso (+ zaehler_aws_iso 1))))
(terpri)
(princ zaehler_aws_iso)
(if (= zaehler_aws_iso 1)
(princ " Objekt "))
(if (or (= zaehler_aws_iso 0) (> zaehler_aws_iso 1))
(princ " Objekte "))
(princ "im Ansichtsfenster isoliert."))))
(defun c:aws_iso ( / erster_layer layername eigenschaftenliste flag_70 naechster_layer layername_n isolierter_auswahlsatz_aws_iso_300 iso_elementanzahl iso_element iso_elementname auswahlsatz_aws_iso_300_g af_mittelpunkt af_hoehe aufloesung pixel_breit pixel_hoch af_breite p1 p2 auswahlsatz_aws_iso_300_a option_aws_iso entity_anzahl entity_nummer zaehler_aws_iso entity_name entity_list entity_list_neu entity_anzahl_isoliert error_akt version cmdecho_akt version_aws_iso)
(setq error_akt *error*)
(setq *error* *aws_iso_error*)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(gesperrte_layer_test_aws_iso_300)
(objektwahl_aws_iso_300)
(if (= isolierter_auswahlsatz_aws_iso_300 nil)
(princ "\nKeine Objekte gefunden. "))
(if (/= isolierter_auswahlsatz_aws_iso_300 nil)
(ausleuchten_aws_iso_300))
(if (/= isolierter_auswahlsatz_aws_iso_300 nil)
(optionsermittlung_aws_iso_300))
(setvar "CMDECHO" 0)
(if (and (/= isolierter_auswahlsatz_aws_iso_300 nil) (= option_aws_iso "Gesamtzeichnung"))
(gesamtzeichnung_aws_iso_300))
(if (and (/= isolierter_auswahlsatz_aws_iso_300 nil) (= option_aws_iso "Ansichtsfenster"))
(ansichtsfenster_aws_iso_300))
(if (and (= option_aws_iso "Gesamtzeichnung") (/= isolierter_auswahlsatz_aws_iso_300 nil) (/= auswahlsatz_aws_iso_300_g nil))
(unsichtbarschalten_g_aws_iso_300))
(if (and (= option_aws_iso "Ansichtsfenster") (/= isolierter_auswahlsatz_aws_iso_300 nil) (/= auswahlsatz_aws_iso_300_a nil))
(unsichtbarschalten_a_aws_iso_300))
(if (and (= option_aws_iso "Ansichtsfenster") (/= isolierter_auswahlsatz_aws_iso_300 nil))
(ergebnisanzeige_a_aws_iso_300))
(if (/= isolierter_auswahlsatz_aws_iso_300 nil)
(r_ausleuchten_aws_iso_300))
(setvar "CMDECHO" cmdecho_akt)
(setq auswahlsatz_aws_iso_300_a nil)
(setq auswahlsatz_aws_iso_300_g nil)
(setq isolierter_auswahlsatz_aws_iso_300 nil)
(setq *error* error_akt)
(princ))
(setq version_aws_iso (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_aws_iso 13) (> version_aws_iso 15))
(princ "\nAutoLISP-Tool AWS_ISO geladen."))
(if (= version_aws_iso 13)
(princ "\nAutoLISP-Tool AWS_ISO fr AutoCAD 13 geladen."))
(if (= version_aws_iso 14)
(princ "\nAutoLISP-Tool AWS_ISO fr AutoCAD 14 geladen."))
(if (= version_aws_iso 15)
(princ "\nAutoLISP-Tool AWS_ISO fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit AWS_ISO auf. ")
(setq version_aws_iso nil)
(princ)
(terpri)

;**************************************************************************

;COL_AUS.LSP

;Programmiert von Gerhard Rampf am 01.04.2000

(defun *col_aus_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= elementname nil)
(redraw elementname 4))
(setq erster_layer nil)
(setq layername nil)
(setq eigenschaftenliste nil)
(setq flag_70 nil)
(setq naechster_layer nil)
(setq layername_n nil)
(setq objekt nil)
(setq elementname nil)
(setq entity_liste nil)
(setq layer nil)
(setq layer_tabelle nil)
(setq farbe_dot nil)
(setq farbe nil)
(setq default_col_aus nil)
(setq farbe_error nil)
(setq farbe_korrekt nil)
(setq auswahlsatz_col_aus_300_g nil)
(setq af_mittelpunkt nil)
(setq af_hoehe nil)
(setq aufloesung nil)
(setq pixel_breit nil)
(setq pixel_hoch nil)
(setq af_breite nil)
(setq p1 nil)
(setq p2 nil)
(setq auswahlsatz_obj_aus_300_a nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq entity_name nil)
(setq entity_list nil)
(setq entity_list_neu nil)
(setq objekt_anzahl nil)
(setq error_akt nil)
(setq vorgabe nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq version_col_aus nil)
(princ))
(defun gesperrte_layer_test_col_aus_300 ()
(setq erster_layer (tblnext "LAYER" T))
(setq layername (cdr (assoc 2 erster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(if (and (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(setq naechster_layer (tblnext "LAYER")))
(while (and (/= naechster_layer nil) (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(progn
(setq layername_n (cdr (assoc 2 naechster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername_n))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(setq naechster_layer (tblnext "LAYER")))))
(defun objektwahl_ov_14_col_aus_300 ()
(setq objekt (entsel "\nFarbe durch Objekt whlen: "))
(while (= objekt nil)
(setq objekt (entsel "\nFarbe durch Objekt whlen: "))))
(defun objektwahl_mv_14_col_aus_300 ()
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objekt whlen <" default_col_aus ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objekt whlen <" default_col_aus ">: "))))))
(defun objektwahl_ov_15_col_aus_300 ()
(setq objekt (entsel "\nFarbe durch Objektwahl angeben: "))
(while (= objekt nil)
(setq objekt (entsel "\nFarbe durch Objektwahl angeben: "))))
(defun objektwahl_mv_15_col_aus_300 ()
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objektwahl angeben <" default_col_aus ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objektwahl angeben <" default_col_aus ">: "))))))
(defun farbnummerermittlung_col_aus_300 ()
(if (/= objekt "")
(progn
(setq elementname (car objekt))
(redraw elementname 3)
(setq entity_liste (entget (car objekt)))
(setq layer (cdr (assoc 8 entity_liste)))
(setq layer_tabelle (tblsearch "LAYER" layer))
(setq farbe_dot (assoc 62 entity_liste))
(if (= farbe_dot nil)
(setq farbe_dot (assoc 62 layer_tabelle)))
(setq farbe (cdr farbe_dot))))
(if (= objekt "")
(setq farbe vorgabe_col_aus_am_300)))
(defun defaultaufbereitung_14_col_aus_300 ()
(if (= vorgabe_col_aus_am_300 0)
(setq default_col_aus "VONBLOCK"))
(if (= vorgabe_col_aus_am_300 1)
(setq default_col_aus "1 (rot)"))
(if (= vorgabe_col_aus_am_300 2)
(setq default_col_aus "2 (gelb)"))
(if (= vorgabe_col_aus_am_300 3)
(setq default_col_aus "3 (grn)"))
(if (= vorgabe_col_aus_am_300 4)
(setq default_col_aus "4 (cyan)"))
(if (= vorgabe_col_aus_am_300 5)
(setq default_col_aus "5 (blau)"))
(if (= vorgabe_col_aus_am_300 6)
(setq default_col_aus "6 (magenta)"))
(if (= vorgabe_col_aus_am_300 7)
(setq default_col_aus "7 (wei)"))
(if (and (> vorgabe_col_aus_am_300 7) (< vorgabe_col_aus_am_300 256))
(setq default_col_aus (itoa vorgabe_col_aus_am_300))))
(defun defaultaufbereitung_15_col_aus_300 ()
(if (= vorgabe_col_aus_am_300 0)
(setq default_col_aus "VonBlock")) 
(if (= vorgabe_col_aus_am_300 1)
(setq default_col_aus "Rot"))
(if (= vorgabe_col_aus_am_300 2)
(setq default_col_aus "Gelb"))
(if (= vorgabe_col_aus_am_300 3)
(setq default_col_aus "Grn"))
(if (= vorgabe_col_aus_am_300 4)
(setq default_col_aus "Cyan"))
(if (= vorgabe_col_aus_am_300 5)
(setq default_col_aus "Blau"))
(if (= vorgabe_col_aus_am_300 6)
(setq default_col_aus "Magenta"))
(if (= vorgabe_col_aus_am_300 7)
(setq default_col_aus "Wei"))
(if (and (> vorgabe_col_aus_am_300 7) (< vorgabe_col_aus_am_300 256))
(setq default_col_aus (strcat "Farbe "(itoa vorgabe_col_aus_am_300)))))
(defun erroraufbereitung_14_col_aus_300 ()
(if (= farbe 0)
(setq farbe_error "VONBLOCK"))
(if (= farbe 1)
(setq farbe_error "1 (rot)"))
(if (= farbe 2)
(setq farbe_error "2 (gelb)"))
(if (= farbe 3)
(setq farbe_error "3 (grn)"))
(if (= farbe 4)
(setq farbe_error "4 (cyan)"))
(if (= farbe 5)
(setq farbe_error "5 (blau)"))
(if (= farbe 6)
(setq farbe_error "6 (magenta)"))
(if (= farbe 7)
(setq farbe_error "7 (wei)"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_error farbe)))
(defun erroraufbereitung_15_col_aus_300 ()
(if (= farbe 0)
(setq farbe_error "VonBlock"))
(if (= farbe 1)
(setq farbe_error "Rot"))
(if (= farbe 2)
(setq farbe_error "Gelb"))
(if (= farbe 3)
(setq farbe_error "Grn"))
(if (= farbe 4)
(setq farbe_error "Cyan"))
(if (= farbe 5)
(setq farbe_error "Blau"))
(if (= farbe 6)
(setq farbe_error "Magenta"))
(if (= farbe 7)
(setq farbe_error "Wei"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_error farbe)))
(defun korrektaufbereitung_14_col_aus_300 ()
(if (= farbe 0)
(setq farbe_korrekt "VONBLOCK"))
(if (=  farbe 1)
(setq farbe_korrekt "1 (rot)"))
(if (=  farbe 2)
(setq farbe_korrekt "2 (gelb)"))
(if (=  farbe 3)
(setq farbe_korrekt "3 (grn)"))
(if (=  farbe 4)
(setq farbe_korrekt "4 (cyan)"))
(if (=  farbe 5)
(setq farbe_korrekt "5 (blau)"))
(if (=  farbe 6)
(setq farbe_korrekt "6 (magenta)"))
(if (=  farbe 7)
(setq farbe_korrekt "7 (wei)"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_korrekt farbe)))
(defun korrektaufbereitung_15_col_aus_300 ()
(if (= farbe 0)
(setq farbe_korrekt "VonBlock")) 
(if (= farbe 1)
(setq farbe_korrekt "Rot"))
(if (= farbe 2)
(setq farbe_korrekt "Gelb"))
(if (= farbe 3)
(setq farbe_korrekt "Grn"))
(if (= farbe 4)
(setq farbe_korrekt "Cyan"))
(if (= farbe 5)
(setq farbe_korrekt "Blau"))
(if (= farbe 6)
(setq farbe_korrekt "Magenta"))
(if (= farbe 7)
(setq farbe_korrekt "Wei"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_korrekt (strcat "Farbe "(itoa farbe)))))
(defun gewaehlte_farbe_ist_col_aus_300 ()
(princ "\nGewhlte Farbe ist ")
(princ farbe_korrekt)
(princ ".")
(princ))
(defun vorgabe_sichern_col_aus_300 ()
(setq vorgabe_col_aus_am_300 farbe))
(defun optionsermittlung_col_aus_300 ()
(initget "Gesamtzeichnung Ansichtsfenster")
(if (or (= option_col_aus_300 nil) (= option_col_aus_300 "Gesamtzeichnung"))
(progn
(if (> version 14)
(setq option_col_aus (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Gesamtzeichnung>: ")))
(if (< version 15)
(setq option_col_aus (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Gesamtzeichnung>: ")))))
(if (= option_col_aus_300 "Ansichtsfenster")
(progn
(if (> version 14)
(setq option_col_aus (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Ansichtsfenster>: ")))
(if (< version 15)
(setq option_col_aus (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Ansichtsfenster>: ")))))
(if (and (= option_col_aus_300 nil) (= option_col_aus nil))
(setq option_col_aus "Gesamtzeichnung"))
(if (and (/= option_col_aus_300 nil) (= option_col_aus nil))
(setq option_col_aus option_col_aus_300))
(setq option_col_aus_300 option_col_aus))
(defun gesamtzeichnung_col_aus_300 ()
(setq auswahlsatz_col_aus_300_g (ssget "X" (list (cons 62 farbe)))))
(defun ansichtsfenster_col_aus_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq auswahlsatz_col_aus_300_a (ssget "_C" p1 p2 (list (cons 62 farbe)))))
(defun unsichtbarschalten_a_col_aus_300 ()
(setq entity_anzahl (sslength auswahlsatz_col_aus_300_a))
(setq entity_nummer (- 0.0 1))
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_col_aus_300_a entity_nummer))
(setq entity_list (entget entity_name))
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))
(entmod entity_list_neu))
(setq objekt_anzahl entity_anzahl)
(if (> objekt_anzahl 0)
(progn
(terpri)
(princ objekt_anzahl)
(if (= objekt_anzahl 1)
(princ " Objekt mit der Farbe "))
(if (> objekt_anzahl 1)
(princ " Objekte mit der Farbe "))
(if (< version 15)
(princ farbe_korrekt))
(if (> version 14)
(princ farbe_error))
(princ " im Ansichtsfenster unsichtbar geschaltet.")))
(terpri))
(defun unsichtbarschalten_g_col_aus_300 ()
(setq entity_anzahl (sslength auswahlsatz_col_aus_300_g))
(setq entity_nummer (- 0.0 1))
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_col_aus_300_g entity_nummer))
(setq entity_list (entget entity_name))
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))
(entmod entity_list_neu))
(setq objekt_anzahl entity_anzahl)
(if (> objekt_anzahl 0)
(progn
(terpri)
(princ objekt_anzahl)
(if (= objekt_anzahl 1)
(princ " Objekt mit der Farbe "))
(if (> objekt_anzahl 1)
(princ " Objekte mit der Farbe "))
(if (< version 15)
(princ farbe_korrekt))
(if (> version 14)
(princ farbe_error))
(princ " in der Gesamtzeichnung unsichtbar geschaltet.")))
(terpri))
(defun keine_objekte_im_ansichtsfenster_col_aus_300 ()
(terpri)
(princ "\nKeine Objekte mit der Farbe ")
(princ farbe_error)
(princ " im Ansichtsfenster gefunden.")
(princ))
(defun keine_objekte_in_der_gesamtzeichnung_col_aus_300 ()
(terpri)
(princ "\nKeine Objekte mit der Farbe ")
(princ farbe_error)
(princ " in der Gesamtzeichnung gefunden.")
(princ))
(defun c:col_aus ( / erster_layer layername eigenschaftenliste flag_70 naechster_layer layername_n objekt elementname entity_liste layer layer_tabelle farbe_dot farbe default_col_aus farbe_error farbe_korrekt option_col_aus auswahlsatz_col_aus_300_g af_mittelpunkt af_hoehe aufloesung pixel_breit pixel_hoch af_breite p1 p2 auswahlsatz_col_aus_300_a entity_anzahl entity_nummer entity_name entity_list entity_list_neu objekt_anzahl error_akt vorgabe version cmdecho_akt version_col_aus)
(setq error_akt *error*)
(setq *error* *col_aus_error*)
(setq vorgabe vorgabe_col_aus_am_300)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
(gesperrte_layer_test_col_aus_300)
(if (and (= vorgabe nil) (> version 14))
(progn
(objektwahl_ov_15_col_aus_300)
(farbnummerermittlung_col_aus_300)
(erroraufbereitung_15_col_aus_300)
(korrektaufbereitung_15_col_aus_300)
(gewaehlte_farbe_ist_col_aus_300)
(vorgabe_sichern_col_aus_300)
(optionsermittlung_col_aus_300)
(if (= option_col_aus "Gesamtzeichnung")
(gesamtzeichnung_col_aus_300))
(if (= option_col_aus "Ansichtsfenster")
(ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (/= auswahlsatz_col_aus_300_g nil))
(unsichtbarschalten_g_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (/= auswahlsatz_col_aus_300_a nil))
(unsichtbarschalten_a_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (= auswahlsatz_col_aus_300_a nil))
(keine_objekte_im_ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (= auswahlsatz_col_aus_300_g nil))
(keine_objekte_in_der_gesamtzeichnung_col_aus_300))))
(if (and (= vorgabe nil) (< version 15))
(progn
(objektwahl_ov_14_col_aus_300)
(farbnummerermittlung_col_aus_300)
(erroraufbereitung_14_col_aus_300)
(korrektaufbereitung_14_col_aus_300)
(gewaehlte_farbe_ist_col_aus_300)
(vorgabe_sichern_col_aus_300)
(optionsermittlung_col_aus_300)
(if (= option_col_aus "Gesamtzeichnung")
(gesamtzeichnung_col_aus_300))
(if (= option_col_aus "Ansichtsfenster")
(ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (/= auswahlsatz_col_aus_300_g nil))
(unsichtbarschalten_g_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (/= auswahlsatz_col_aus_300_a nil))
(unsichtbarschalten_a_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (= auswahlsatz_col_aus_300_a nil))
(keine_objekte_im_ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (= auswahlsatz_col_aus_300_g nil))
(keine_objekte_in_der_gesamtzeichnung_col_aus_300))))
(if (and (/= vorgabe nil) (> version 14))
(progn
(defaultaufbereitung_15_col_aus_300)
(objektwahl_mv_15_col_aus_300)
(farbnummerermittlung_col_aus_300)
(erroraufbereitung_15_col_aus_300)
(korrektaufbereitung_15_col_aus_300)
(gewaehlte_farbe_ist_col_aus_300)
(vorgabe_sichern_col_aus_300)
(optionsermittlung_col_aus_300)
(if (= option_col_aus "Gesamtzeichnung")
(gesamtzeichnung_col_aus_300))
(if (= option_col_aus "Ansichtsfenster")
(ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (/= auswahlsatz_col_aus_300_g nil))
(unsichtbarschalten_g_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (/= auswahlsatz_col_aus_300_a nil))
(unsichtbarschalten_a_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (= auswahlsatz_col_aus_300_a nil))
(keine_objekte_im_ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (= auswahlsatz_col_aus_300_g nil))
(keine_objekte_in_der_gesamtzeichnung_col_aus_300))))
(if (and (/= vorgabe nil) (< version 15))
(progn
(defaultaufbereitung_14_col_aus_300)
(objektwahl_mv_14_col_aus_300)
(farbnummerermittlung_col_aus_300)
(erroraufbereitung_14_col_aus_300)
(korrektaufbereitung_14_col_aus_300)
(gewaehlte_farbe_ist_col_aus_300)
(vorgabe_sichern_col_aus_300)
(optionsermittlung_col_aus_300)
(if (= option_col_aus "Gesamtzeichnung")
(gesamtzeichnung_col_aus_300))
(if (= option_col_aus "Ansichtsfenster")
(ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (/= auswahlsatz_col_aus_300_g nil))
(unsichtbarschalten_g_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (/= auswahlsatz_col_aus_300_a nil))
(unsichtbarschalten_a_col_aus_300))
(if (and (= option_col_aus "Ansichtsfenster") (= auswahlsatz_col_aus_300_a nil))
(keine_objekte_im_ansichtsfenster_col_aus_300))
(if (and (= option_col_aus "Gesamtzeichnung") (= auswahlsatz_col_aus_300_g nil))
(keine_objekte_in_der_gesamtzeichnung_col_aus_300))))
(if (/= elementname nil)
(redraw elementname 4))
(setq *error* error_akt)
(setvar "CMDECHO" cmdecho_akt)
(setq auswahlsatz_col_aus_300_a nil)
(setq auswahlsatz_col_aus_300_g nil)
(princ))
(setq version_col_aus (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_col_aus 13) (> version_col_aus 15))
(princ "\nAutoLISP-Tool COL_AUS geladen."))
(if (= version_col_aus 13)
(princ "\nAutoLISP-Tool COL_AUS fr AutoCAD 13 geladen."))
(if (= version_col_aus 14)
(princ "\nAutoLISP-Tool COL_AUS fr AutoCAD 14 geladen."))
(if (= version_col_aus 15)
(princ "\nAutoLISP-Tool COL_AUS fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit COL_AUS auf. ")
(setq version_col_aus nil)
(princ)
(terpri)

;*************************************************************************

;COL_ISO.LSP

;Programmiert von Gerhard Rampf am 01.04.2000

(defun *col_iso_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= elementname nil)
(redraw elementname 4))
(setq erster_layer nil)
(setq layername nil)
(setq eigenschaftenliste nil)
(setq flag_70 nil)
(setq naechster_layer nil)
(setq layername_n nil)
(setq objekt nil)
(setq elementname nil)
(setq entity_liste nil)
(setq layer nil)
(setq layer_tabelle nil)
(setq farbe_dot nil)
(setq farbe nil)
(setq default_col_iso nil)
(setq farbe_error nil)
(setq farbe_korrekt nil)
(setq option_col_iso nil)
(setq gesamtchek_col_iso_300 nil)
(setq af_mittelpunkt nil)
(setq af_hoehe nil)
(setq aufloesung nil)
(setq pixel_breit nil)
(setq pixel_hoch nil)
(setq af_breite nil)
(setq p1 nil)
(setq p2 nil)
(setq ansichtchek_col_iso_300 nil)
(setq auswahlsatz_col_iso_300_g nil)
(setq auswahlsatz_obj_aus_300_a nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq zaehlerbasis nil)
(setq entity_name nil)
(setq entity_list nil)
(setq entity_list_neu_unsichtbar nil)
(setq entity_list_neu nil)
(setq error_akt nil)
(setq vorgabe nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq version_col_iso nil)
(princ))
(defun gesperrte_layer_test_col_iso_300 ()
(setq erster_layer (tblnext "LAYER" T))
(setq layername (cdr (assoc 2 erster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(if (and (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(setq naechster_layer (tblnext "LAYER")))
(while (and (/= naechster_layer nil) (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(progn
(setq layername_n (cdr (assoc 2 naechster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername_n))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(setq naechster_layer (tblnext "LAYER")))))
(defun objektwahl_ov_14_col_iso_300 ()
(setq objekt (entsel "\nFarbe durch Objekt whlen: "))
(while (= objekt nil)
(setq objekt (entsel "\nFarbe durch Objekt whlen: "))))
(defun objektwahl_mv_14_col_iso_300 ()
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objekt whlen <" default_col_iso ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objekt whlen <" default_col_iso ">: "))))))
(defun objektwahl_ov_15_col_iso_300 ()
(setq objekt (entsel "\nFarbe durch Objektwahl angeben: "))
(while (= objekt nil)
(setq objekt (entsel "\nFarbe durch Objektwahl angeben: "))))
(defun objektwahl_mv_15_col_iso_300 ()
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objektwahl angeben <" default_col_iso ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nFarbe durch Objektwahl angeben <" default_col_iso ">: "))))))
(defun farbnummerermittlung_col_iso_300 ()
(if (/= objekt "")
(progn
(setq elementname (car objekt))
(redraw elementname 3)
(setq entity_liste (entget (car objekt)))
(setq layer (cdr (assoc 8 entity_liste)))
(setq layer_tabelle (tblsearch "LAYER" layer))
(setq farbe_dot (assoc 62 entity_liste))
(if (= farbe_dot nil)
(setq farbe_dot (assoc 62 layer_tabelle)))
(setq farbe (cdr farbe_dot))))
(if (= objekt "")
(setq farbe vorgabe_col_iso_am_300)))
(defun defaultaufbereitung_14_col_iso_300 ()
(if (= vorgabe_col_iso_am_300 0)
(setq default_col_iso "VONBLOCK"))
(if (= vorgabe_col_iso_am_300 1)
(setq default_col_iso "1 (rot)"))
(if (= vorgabe_col_iso_am_300 2)
(setq default_col_iso "2 (gelb)"))
(if (= vorgabe_col_iso_am_300 3)
(setq default_col_iso "3 (grn)"))
(if (= vorgabe_col_iso_am_300 4)
(setq default_col_iso "4 (cyan)"))
(if (= vorgabe_col_iso_am_300 5)
(setq default_col_iso "5 (blau)"))
(if (= vorgabe_col_iso_am_300 6)
(setq default_col_iso "6 (magenta)"))
(if (= vorgabe_col_iso_am_300 7)
(setq default_col_iso "7 (wei)"))
(if (and (> vorgabe_col_iso_am_300 7) (< vorgabe_col_iso_am_300 256))
(setq default_col_iso (itoa vorgabe_col_iso_am_300))))
(defun defaultaufbereitung_15_col_iso_300 ()
(if (= vorgabe_col_iso_am_300 0)
(setq default_col_iso "VonBlock")) 
(if (= vorgabe_col_iso_am_300 1)
(setq default_col_iso "Rot"))
(if (= vorgabe_col_iso_am_300 2)
(setq default_col_iso "Gelb"))
(if (= vorgabe_col_iso_am_300 3)
(setq default_col_iso "Grn"))
(if (= vorgabe_col_iso_am_300 4)
(setq default_col_iso "Cyan"))
(if (= vorgabe_col_iso_am_300 5)
(setq default_col_iso "Blau"))
(if (= vorgabe_col_iso_am_300 6)
(setq default_col_iso "Magenta"))
(if (= vorgabe_col_iso_am_300 7)
(setq default_col_iso "Wei"))
(if (and (> vorgabe_col_iso_am_300 7) (< vorgabe_col_iso_am_300 256))
(setq default_col_iso (strcat "Farbe "(itoa vorgabe_col_iso_am_300)))))
(defun erroraufbereitung_14_col_iso_300 ()
(if (= farbe 0)
(setq farbe_error "VONBLOCK"))
(if (= farbe 1)
(setq farbe_error "1 (rot)"))
(if (= farbe 2)
(setq farbe_error "2 (gelb)"))
(if (= farbe 3)
(setq farbe_error "3 (grn)"))
(if (= farbe 4)
(setq farbe_error "4 (cyan)"))
(if (= farbe 5)
(setq farbe_error "5 (blau)"))
(if (= farbe 6)
(setq farbe_error "6 (magenta)"))
(if (= farbe 7)
(setq farbe_error "7 (wei)"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_error farbe)))
(defun erroraufbereitung_15_col_iso_300 ()
(if (= farbe 0)
(setq farbe_error "VonBlock"))
(if (= farbe 1)
(setq farbe_error "Rot"))
(if (= farbe 2)
(setq farbe_error "Gelb"))
(if (= farbe 3)
(setq farbe_error "Grn"))
(if (= farbe 4)
(setq farbe_error "Cyan"))
(if (= farbe 5)
(setq farbe_error "Blau"))
(if (= farbe 6)
(setq farbe_error "Magenta"))
(if (= farbe 7)
(setq farbe_error "Wei"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_error farbe)))
(defun korrektaufbereitung_14_col_iso_300 ()
(if (= farbe 0)
(setq farbe_korrekt "VONBLOCK"))
(if (=  farbe 1)
(setq farbe_korrekt "1 (rot)"))
(if (=  farbe 2)
(setq farbe_korrekt "2 (gelb)"))
(if (=  farbe 3)
(setq farbe_korrekt "3 (grn)"))
(if (=  farbe 4)
(setq farbe_korrekt "4 (cyan)"))
(if (=  farbe 5)
(setq farbe_korrekt "5 (blau)"))
(if (=  farbe 6)
(setq farbe_korrekt "6 (magenta)"))
(if (=  farbe 7)
(setq farbe_korrekt "7 (wei)"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_korrekt farbe)))
(defun korrektaufbereitung_15_col_iso_300 ()
(if (= farbe 0)
(setq farbe_korrekt "VonBlock")) 
(if (= farbe 1)
(setq farbe_korrekt "Rot"))
(if (= farbe 2)
(setq farbe_korrekt "Gelb"))
(if (= farbe 3)
(setq farbe_korrekt "Grn"))
(if (= farbe 4)
(setq farbe_korrekt "Cyan"))
(if (= farbe 5)
(setq farbe_korrekt "Blau"))
(if (= farbe 6)
(setq farbe_korrekt "Magenta"))
(if (= farbe 7)
(setq farbe_korrekt "Wei"))
(if (and (> farbe 7) (< farbe 256))
(setq farbe_korrekt (strcat "Farbe "(itoa farbe)))))
(defun gewaehlte_farbe_ist_col_iso_300 ()
(princ "\nGewhlte Farbe ist ")
(princ farbe_korrekt)
(princ ".")
(princ))
(defun vorgabe_sichern_col_iso_300 ()
(setq vorgabe_col_iso_am_300 farbe))
(defun optionsermittlung_col_iso_300 ()
(initget "Gesamtzeichnung Ansichtsfenster")
(if (or (= option_col_iso_300 nil) (= option_col_iso_300 "Gesamtzeichnung"))
(progn
(if (> version 14)
(setq option_col_iso (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Gesamtzeichnung>: ")))
(if (< version 15)
(setq option_col_iso (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Gesamtzeichnung>: ")))))
(if (= option_col_iso_300 "Ansichtsfenster")
(progn
(if (> version 14)
(setq option_col_iso (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Ansichtsfenster>: ")))
(if (< version 15)
(setq option_col_iso (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Ansichtsfenster>: ")))))
(if (and (= option_col_iso_300 nil) (= option_col_iso nil))
(setq option_col_iso "Gesamtzeichnung"))
(if (and (/= option_col_iso_300 nil) (= option_col_iso nil))
(setq option_col_iso option_col_iso_300))
(setq option_col_iso_300 option_col_iso))
(defun gesamtzeichnung_pruefung_col_iso_300 ()
(setq gesamtchek_col_iso_300 (ssget "X" (list (cons 62 farbe)))))
(defun ansichtsfenster_pruefung_col_iso_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq ansichtchek_col_iso_300 (ssget "_C" p1 p2 (list (cons 62 farbe)))))
(defun gesamtzeichnung_col_iso_300 ()
(setq auswahlsatz_col_iso_300_g (ssget "X")))
(defun ansichtsfenster_col_iso_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq auswahlsatz_col_iso_300_a (ssget "_C" p1 p2)))
(defun unsichtbarschalten_g_col_iso_300 ()
(setq entity_anzahl (sslength auswahlsatz_col_iso_300_g))
(setq entity_nummer (- 0.0 1))
(setq zaehlerbasis 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_col_iso_300_g entity_nummer))
(setq entity_list (entget entity_name))
(if (= (cdr (assoc 62 entity_list)) farbe)
(progn
;(setq gefunden_ja "ja")
(setq zaehlerbasis (+ zaehlerbasis 1))))
(if (and (= (cdr (assoc 62 entity_list)) farbe) (= (cdr (assoc 60 entity_list)) 1))
(progn
(setq entity_list_neu_unsichtbar (subst (cons 60 0) (assoc 60 entity_list) entity_list))
(entmod entity_list_neu_unsichtbar)))
(if (/= (cdr (assoc 62 entity_list)) farbe)
(progn
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))))
(entmod entity_list_neu)))
(defun unsichtbarschalten_a_col_iso_300 ()
(setq entity_anzahl (sslength auswahlsatz_col_iso_300_a))
(setq entity_nummer (- 0.0 1))
(setq zaehlerbasis 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_col_iso_300_a entity_nummer))
(setq entity_list (entget entity_name))
(if (= (cdr (assoc 62 entity_list)) farbe)
(progn
;(setq gefunden_ja "ja")
(setq zaehlerbasis (+ zaehlerbasis 1))))
(if (/= (cdr (assoc 62 entity_list)) farbe)
(progn
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))))
(entmod entity_list_neu)))
(defun ergebnisanzeige_g_col_iso_300 ()
(if (> zaehlerbasis 0)
(progn
(terpri)
(princ zaehlerbasis)
(if (= zaehlerbasis 1)
(princ " Objekt mit der Farbe "))
(if (> zaehlerbasis 1)
(princ " Objekte mit der Farbe "))
(if (< version 15)
(princ farbe_korrekt))
(if (> version 14)
(princ farbe_error))
(princ " in der Gesamtzeichnung isoliert.")
(terpri))))
(defun ergebnisanzeige_a_col_iso_300 ()
(if (> zaehlerbasis 0)
(progn
(terpri)
(princ zaehlerbasis)
(if (= zaehlerbasis 1)
(princ " Objekt mit der Farbe "))
(if (> zaehlerbasis 1)
(princ " Objekte mit der Farbe "))
(if (< version 15)
(princ farbe_korrekt))
(if (> version 14)
(princ farbe_error))
(princ " im Ansichtsfenster isoliert.")
(terpri))))
(defun af_auswahl_nil_col_iso_300 ()
(terpri)
(princ "\nKeine Objekte mit der Farbe ")
(if (< version 15)
(princ farbe_korrekt))
(if (> version 14)
(princ farbe_error))
(princ " im Ansichtsfenster gefunden.")
(princ))
(defun gz_auswahl_nil_col_iso_300 ()
(terpri)
(princ "\nKeine Objekte mit der Farbe ")
(if (< version 15)
(princ farbe_korrekt))
(if (> version 14)
(princ farbe_error))
(princ " in der Gesamtzeichnung gefunden.")
(princ))
(defun c:col_iso ( / erster_layer layername eigenschaftenliste flag_70 naechster_layer layername_n objekt elementname entity_liste layer layer_tabelle farbe_dot farbe default_col_iso farbe_error farbe_korrekt option_col_iso gesamtchek_col_iso_300 af_mittelpunkt af_hoehe aufloesung pixel_breit pixel_hoch af_breite p1 p2 ansichtchek_col_iso_300 auswahlsatz_col_iso_300_g auswahlsatz_col_iso_300_a entity_anzahl entity_nummer zaehlerbasis entity_name entity_list entity_list_neu_unsichtbar entity_list_neu error_akt vorgabe version cmdecho_akt version_col_iso)
(setq error_akt *error*)
(setq *error* *col_iso_error*)
(setq vorgabe vorgabe_col_iso_am_300)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
(gesperrte_layer_test_col_iso_300)
(if (and (= vorgabe nil) (> version 14))
(progn
(objektwahl_ov_15_col_iso_300)
(farbnummerermittlung_col_iso_300)
(erroraufbereitung_15_col_iso_300)
(korrektaufbereitung_15_col_iso_300)))
(if (and (= vorgabe nil) (< version 15))
(progn
(objektwahl_ov_14_col_iso_300)
(farbnummerermittlung_col_iso_300)
(erroraufbereitung_14_col_iso_300)
(korrektaufbereitung_14_col_iso_300)))
(if (and (/= vorgabe nil) (> version 14))
(progn
(defaultaufbereitung_15_col_iso_300)
(objektwahl_mv_15_col_iso_300)
(farbnummerermittlung_col_iso_300)
(erroraufbereitung_15_col_iso_300)
(korrektaufbereitung_15_col_iso_300)))
(if (and (/= vorgabe nil) (< version 15))
(progn
(defaultaufbereitung_14_col_iso_300)
(objektwahl_mv_14_col_iso_300)
(farbnummerermittlung_col_iso_300)
(erroraufbereitung_14_col_iso_300)
(korrektaufbereitung_14_col_iso_300)))
(gewaehlte_farbe_ist_col_iso_300)
(vorgabe_sichern_col_iso_300)
(optionsermittlung_col_iso_300)
(if (= option_col_iso "Gesamtzeichnung")
(gesamtzeichnung_col_iso_300))
(if (= option_col_iso "Gesamtzeichnung")
(gesamtzeichnung_pruefung_col_iso_300))
(if (= option_col_iso "Ansichtsfenster")
(ansichtsfenster_col_iso_300))
(if (= option_col_iso "Ansichtsfenster")
(ansichtsfenster_pruefung_col_iso_300))
(if (and (= option_col_iso "Gesamtzeichnung") (/= auswahlsatz_col_iso_300_g nil) (/= gesamtchek_col_iso_300 nil))
(unsichtbarschalten_g_col_iso_300))
(if (and (= option_col_iso "Gesamtzeichnung") (/= auswahlsatz_col_iso_300_g nil) (/= gesamtchek_col_iso_300 nil))
(ergebnisanzeige_g_col_iso_300))
(if (and (= option_col_iso "Ansichtsfenster") (/= auswahlsatz_col_iso_300_a nil) (/= ansichtchek_col_iso_300 nil))
(unsichtbarschalten_a_col_iso_300))
(if (and (= option_col_iso "Ansichtsfenster") (/= auswahlsatz_col_iso_300_a nil) (/= ansichtchek_col_iso_300 nil))
(ergebnisanzeige_a_col_iso_300))
(if (and (= option_col_iso "Ansichtsfenster") (= ansichtchek_col_iso_300 nil))
(af_auswahl_nil_col_iso_300))
(if (and (= option_col_iso "Gesamtzeichnung") (= gesamtchek_col_iso_300 nil))
(gz_auswahl_nil_col_iso_300))
(if (/= elementname nil)
(redraw elementname 4))
(setq *error* error_akt)
(setvar "CMDECHO" cmdecho_akt)
(setq auswahlsatz_col_iso_300_a nil)
(setq auswahlsatz_col_iso_300_g nil)
(princ))
(setq version_col_iso (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_col_iso 13) (> version_col_iso 15))
(princ "\nAutoLISP-Tool COL_ISO geladen."))
(if (= version_col_iso 13)
(princ "\nAutoLISP-Tool COL_ISO fr AutoCAD 13 geladen."))
(if (= version_col_iso 14)
(princ "\nAutoLISP-Tool COL_ISO fr AutoCAD 14 geladen."))
(if (= version_col_iso 15)
(princ "\nAutoLISP-Tool COL_ISO fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit COL_ISO auf. ")
(setq version_col_iso nil)
(princ)
(terpri)

;*************************************************************************

;OBJ_AUS.LSP

;Programmiert von Gerhard Rampf am 01.04.2000

(defun *obj_aus_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= objektname nil)
(redraw objektname 4))
(setq erster_layer nil)
(setq layername nil)
(setq eigenschaftenliste nil)
(setq flag_70 nil)
(setq naechster_layer nil)
(setq layername_n nil)
(setq default_obj_aus nil)
(setq code0 nil)
(setq auswahlsatz_obj_aus_300_g nil)
(setq af_mittelpunkt nil)
(setq af_hoehe nil)
(setq aufloesung nil)
(setq pixel_breit nil)
(setq pixel_hoch nil)
(setq af_breite nil)
(setq p1 nil)
(setq p2 nil)
(setq auswahlsatz_obj_aus_300_a nil)
(setq objekt nil)
(setq objektname nil)
(setq entityliste nil)
(setq ent nil)
(setq filter nil)
(setq option_obj_aus nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq entity_name nil)
(setq entity_list nil)
(setq entity_list_neu nil)
(setq objekt_anzahl nil)
(setq error_akt nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq version_obj_aus nil)
(princ))
(defun gesperrte_layer_test_obj_aus_300 ()
(setq erster_layer (tblnext "LAYER" T))
(setq layername (cdr (assoc 2 erster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(if (and (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(setq naechster_layer (tblnext "LAYER")))
(while (and (/= naechster_layer nil) (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(progn
(setq layername_n (cdr (assoc 2 naechster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername_n))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(setq naechster_layer (tblnext "LAYER")))))
(defun default_setzen_obj_aus_300 ()
(if (= vorgabe_obj_aus_am_300 "3DFACE")
(setq default_obj_aus "3D-FLCHE"))
(if (and (< version 14) (= vorgabe_obj_aus_am_300 "3DSOLID"))
(setq default_obj_aus "FESTKRPER"))
(if (and (= version 14) (= vorgabe_obj_aus_am_300 "3DSOLID"))
(setq default_obj_aus "VOLUMENKRPER"))
(if (and (> version 14) (= vorgabe_obj_aus_am_300 "3DSOLID"))
(setq default_obj_aus "3D-VOLUMENKRPER"))
(if (= vorgabe_obj_aus_am_300 "ARC")
(setq default_obj_aus "BOGEN"))
(if (and (< version 15) (= vorgabe_obj_aus_am_300 "ATTDEF"))
(setq default_obj_aus "ATTRIBUTSBEZEICHNUNG"))
(if (and (> version 14) (= vorgabe_obj_aus_am_300 "ATTDEF"))
(setq default_obj_aus "ATTRIBUT"))
(if (and (= version 13) (= vorgabe_obj_aus_am_300 "BODY"))
(setq default_obj_aus "KRPER"))
(if (and (= version 14) (= vorgabe_obj_aus_am_300 "BODY"))
(setq default_obj_aus "ACIS-FLCHE"))
(if (and (> version 14) (= vorgabe_obj_aus_am_300 "BODY"))
(setq default_obj_aus "BODY"))
(if (= vorgabe_obj_aus_am_300 "CIRCLE")
(setq default_obj_aus "KREIS"))
(if (= vorgabe_obj_aus_am_300 "DIMENSION")
(setq default_obj_aus "BEMASSUNG"))
(if (= vorgabe_obj_aus_am_300 "ELLIPSE")
(setq default_obj_aus "ELLIPSE"))
(if (= vorgabe_obj_aus_am_300 "HATCH")
(setq default_obj_aus "SCHRAFFUR"))
(if (and (= version 14) (= vorgabe_obj_aus_am_300 "IMAGE"))
(setq default_obj_aus "BILD"))
(if (and (> version 14) (= vorgabe_obj_aus_am_300 "IMAGE"))
(setq default_obj_aus "PIXELBILD"))
(if (= vorgabe_obj_aus_am_300 "INSERT")
(setq default_obj_aus "BLOCKREFERENZ"))
(if (= vorgabe_obj_aus_am_300 "LEADER")
(setq default_obj_aus "FHRUNG"))
(if (= vorgabe_obj_aus_am_300 "LINE")
(setq default_obj_aus "LINIE"))
(if (= vorgabe_obj_aus_am_300 "LWPOLYLINE")
(setq default_obj_aus "LW-POLYLINIE"))
(if (and (< version 15) (= vorgabe_obj_aus_am_300 "MLINE"))
(setq default_obj_aus "MULTILINIE"))
(if (and (> version 14) (= vorgabe_obj_aus_am_300 "MLINE"))
(setq default_obj_aus "MLINIE"))
(if (= vorgabe_obj_aus_am_300 "MTEXT")
(setq default_obj_aus "MTEXT"))
(if (= vorgabe_obj_aus_am_300 "POINT")
(setq default_obj_aus "PUNKT"))
(if (= vorgabe_obj_aus_am_300 "POLYLINE")
(setq default_obj_aus "POLYLINIE"))
(if (= vorgabe_obj_aus_am_300 "RAY")
(setq default_obj_aus "STRAHL"))
(if (= vorgabe_obj_aus_am_300 "REGION")
(setq default_obj_aus "REGION"))
(if (= vorgabe_obj_aus_am_300 "SHAPE")
(setq default_obj_aus "SYMBOL"))
(if (= vorgabe_obj_aus_am_300 "SOLID")
(setq default_obj_aus "SOLID"))
(if (= vorgabe_obj_aus_am_300 "SPLINE")
(setq default_obj_aus "SPLINE"))
(if (= vorgabe_obj_aus_am_300 "TEXT")
(setq default_obj_aus "TEXT"))
(if (= vorgabe_obj_aus_am_300 "TOLERANCE")
(setq default_obj_aus "TOLERANZ"))
(if (= vorgabe_obj_aus_am_300 "TRACE")
(setq default_obj_aus "BAND"))
(if (= vorgabe_obj_aus_am_300 "VIEWPORT")
(setq default_obj_aus "ANSICHTSFENSTER"))
(if (= vorgabe_obj_aus_am_300 "XLINE")
(setq default_obj_aus "KLINIE"))
(if (and (/= vorgabe_obj_aus_am_300 "3DFACE") (/= vorgabe_obj_aus_am_300 "3DSOLID") (/= vorgabe_obj_aus_am_300 "ARC") (/= vorgabe_obj_aus_am_300 "ATTDEF") (/= vorgabe_obj_aus_am_300 "BODY") (/= vorgabe_obj_aus_am_300 "CIRCLE") (/= vorgabe_obj_aus_am_300 "DIMENSION") (/= vorgabe_obj_aus_am_300 "ELLIPSE") (/= vorgabe_obj_aus_am_300 "HATCH") (/= vorgabe_obj_aus_am_300 "IMAGE") (/= vorgabe_obj_aus_am_300 "INSERT") (/= vorgabe_obj_aus_am_300 "LEADER") (/= vorgabe_obj_aus_am_300 "LINE") (/= vorgabe_obj_aus_am_300 "LWPOLYLINE") (/= vorgabe_obj_aus_am_300 "MLINE") (/= vorgabe_obj_aus_am_300 "MTEXT") (/= vorgabe_obj_aus_am_300 "POINT") (/= vorgabe_obj_aus_am_300 "POLYLINE") (/= vorgabe_obj_aus_am_300 "RAY") (/= vorgabe_obj_aus_am_300 "REGION") (/= vorgabe_obj_aus_am_300 "SHAPE") (/= vorgabe_obj_aus_am_300 "SOLID") (/= vorgabe_obj_aus_am_300 "SPLINE") (/= vorgabe_obj_aus_am_300 "TEXT") (/= vorgabe_obj_aus_am_300 "TOLERANCE") (/= vorgabe_obj_aus_am_300 "TRACE") (/= vorgabe_obj_aus_am_300 "VIEWPORT") (/= vorgabe_obj_aus_am_300 "XLINE"))
(setq default_obj_aus vorgabe_obj_aus_am_300)))
(defun anzeige_des_gewaehlten_objekttyps_obj_aus_300 ()
(if (= code0 "3DFACE")
(setq code0 "3D-FLCHE"))
(if (and (< version 14) (= code0 "3DSOLID"))
(setq code0 "FESTKRPER"))
(if (and (= version 14) (= code0 "3DSOLID"))
(setq code0 "VOLUMENKRPER"))
(if (and (> version 14) (= code0 "3DSOLID"))
(setq code0 "3D-VOLUMENKRPER"))
(if (= code0 "ARC")
(setq code0 "BOGEN"))
(if (and (< version 15) (= code0 "ATTDEF"))
(setq code0 "ATTRIBUTSBEZEICHNUNG"))
(if (and (> version 14) (= code0 "ATTDEF"))
(setq code0 "ATTRIBUT"))
(if (and (= version 13) (= code0 "BODY"))
(setq code0 "KRPER"))
(if (and (= version 14) (= code0 "BODY"))
(setq code0 "ACIS-FLCHE"))
(if (and (> version 14) (= code0 "BODY"))
(setq code0 "BODY"))
(if (= code0 "CIRCLE")
(setq code0 "KREIS"))
(if (= code0 "DIMENSION")
(setq code0 "BEMASSUNG"))
(if (= code0 "ELLIPSE")
(setq code0 "ELLIPSE"))
(if (= code0 "HATCH")
(setq code0 "SCHRAFFUR"))
(if (and (= version 14) (= code0 "IMAGE"))
(setq code0 "BILD"))
(if (and (> version 14) (= code0 "IMAGE"))
(setq code0 "PIXELBILD"))
(if (= code0 "INSERT")
(setq code0 "BLOCKREFERENZ"))
(if (= code0 "LEADER")
(setq code0 "FHRUNG"))
(if (= code0 "LINE")
(setq code0 "LINIE"))
(if (= code0 "LWPOLYLINE")
(setq code0 "LW-POLYLINIE"))
(if (and (< version 15) (= code0 "MLINE"))
(setq code0 "MULTILINIE"))
(if (and (> version 14) (= code0 "MLINE"))
(setq code0 "MLINIE"))
(if (= code0 "MTEXT")
(setq code0 "MTEXT"))
(if (= code0 "POINT")
(setq code0 "PUNKT"))
(if (= code0 "POLYLINE")
(setq code0 "POLYLINIE"))
(if (= code0 "RAY")
(setq code0 "STRAHL"))
(if (= code0 "REGION")
(setq code0 "REGION"))
(if (= code0 "SHAPE")
(setq code0 "SYMBOL"))
(if (= code0 "SOLID")
(setq code0 "SOLID"))
(if (= code0 "SPLINE")
(setq code0 "SPLINE"))
(if (= code0 "TEXT")
(setq code0 "TEXT"))
(if (= code0 "TOLERANCE")
(setq code0 "TOLERANZ"))
(if (= code0 "TRACE")
(setq code0 "BAND"))
(if (= code0 "VIEWPORT")
(setq code0 "ANSICHTSFENSTER"))
(if (= code0 "XLINE")
(setq code0 "KLINIE"))
(if (and (/= code0 "3DFACE") (/= code0 "3DSOLID") (/= code0 "ARC") (/= code0 "ATTDEF") (/= code0 "BODY") (/= code0 "CIRCLE") (/= code0 "DIMENSION") (/= code0 "ELLIPSE") (/= code0 "HATCH") (/= code0 "IMAGE") (/= code0 "INSERT") (/= code0 "LEADER") (/= code0 "LINE") (/= code0 "LWPOLYLINE") (/= code0 "MLINE") (/= code0 "MTEXT") (/= code0 "POINT") (/= code0 "POLYLINE") (/= code0 "RAY") (/= code0 "REGION") (/= code0 "SHAPE") (/= code0 "SOLID") (/= code0 "SPLINE") (/= code0 "TEXT") (/= code0 "TOLERANCE") (/= code0 "TRACE") (/= code0 "VIEWPORT") (/= code0 "XLINE"))
(setq code0 code0))
(princ "\nGewhlter Objekttyp = ")
(princ code0)
(princ ".")
(princ)
(terpri))
(defun gesamtzeichnung_obj_aus_300 ()
(setq auswahlsatz_obj_aus_300_g (ssget "X" (list (cons 0 filter)))))
(defun ansichtsfenster_obj_aus_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq auswahlsatz_obj_aus_300_a (ssget "_C" p1 p2 (list (cons 0 filter)))))
(defun objekttypwahl_obj_aus_300 ()
(if (and (< version 15) (= vorgabe_obj_aus_am_300 nil))
(progn
(setq objekt (entsel "\nObjekttyp durch Objekt whlen: "))
(while (= objekt nil)
(setq objekt (entsel "\nObjekttyp durch Objekt whlen: ")))))
(if (and (< version 15) (/= vorgabe_obj_aus_am_300 nil))
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objekt whlen <" default_obj_aus ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objekt whlen <" default_obj_aus ">: ")))))))
(if (and (> version 14) (= vorgabe_obj_aus_am_300 nil))
(progn
(setq objekt (entsel "\nObjekttyp durch Objektwahl angeben: "))
(while (= objekt nil)
(setq objekt (entsel "\nObjekttyp durch Objektwahl angeben: ")))))
(if (and (> version 14) (/= vorgabe_obj_aus_am_300 nil))
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objektwahl angeben <" default_obj_aus ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objektwahl angeben <" default_obj_aus ">: ")))))))
(if (/= objekt "")
(progn
(setq objektname (car objekt))
(redraw objektname 3)
(setq entityliste (entget (car objekt)))
(setq ent (assoc 0 entityliste))
(setq filter (cdr ent))))
(if (= objekt "")
(setq filter vorgabe_obj_aus_am_300))
(setq code0 filter)
(setq vorgabe_obj_aus_am_300 filter))
(defun optionsermittlung_obj_aus_300 ()
(initget "Gesamtzeichnung Ansichtsfenster")
(if (or (= option_obj_aus_300 nil) (= option_obj_aus_300 "Gesamtzeichnung"))
(progn
(if (> version 14)
(setq option_obj_aus (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Gesamtzeichnung>: ")))
(if (< version 15)
(setq option_obj_aus (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Gesamtzeichnung>: ")))))
(if (= option_obj_aus_300 "Ansichtsfenster")
(progn
(if (> version 14)
(setq option_obj_aus (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Ansichtsfenster>: ")))
(if (< version 15)
(setq option_obj_aus (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Ansichtsfenster>: ")))))
(if (and (= option_obj_aus_300 nil) (= option_obj_aus nil))
(setq option_obj_aus "Gesamtzeichnung"))
(if (and (/= option_obj_aus_300 nil) (= option_obj_aus nil))
(setq option_obj_aus option_obj_aus_300))
(setq option_obj_aus_300 option_obj_aus))
(defun unsichtbarschalten_a_obj_aus_300 ()
(setq entity_anzahl (sslength auswahlsatz_obj_aus_300_a))
(setq entity_nummer (- 0.0 1))
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_obj_aus_300_a entity_nummer))
(setq entity_list (entget entity_name))
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))
(entmod entity_list_neu))
(setq objekt_anzahl entity_anzahl)
(if (> objekt_anzahl 0)
(progn
(terpri)
(princ objekt_anzahl)
(if (= objekt_anzahl 1)
(princ " Objekt des Objekttyps "))
(if (> objekt_anzahl 1)
(princ " Objekte des Objekttyps "))
(princ code0)
(princ " im Ansichtsfenster unsichtbar geschaltet.")))
(terpri))
(defun unsichtbarschalten_g_obj_aus_300 ()
(setq entity_anzahl (sslength auswahlsatz_obj_aus_300_g))
(setq entity_nummer (- 0.0 1))
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_obj_aus_300_g entity_nummer))
(setq entity_list (entget entity_name))
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))
(entmod entity_list_neu))
(setq objekt_anzahl entity_anzahl)
(if (> objekt_anzahl 0)
(progn
(terpri)
(princ objekt_anzahl)
(if (= objekt_anzahl 1)
(princ " Objekt des Objekttyps "))
(if (> objekt_anzahl 1)
(princ " Objekte des Objekttyps "))
(princ code0)
(princ " in der Gesamtzeichnung unsichtbar geschaltet.")))
(terpri))
(defun keine_objekte_im_ansichtsfenster_obj_aus_300 ()
(terpri)
(princ "\nKeine Objekte des Objekttyps ")
(princ code0)
(princ " im Ansichtsfenster gefunden.")
(princ))
(defun keine_objekte_in_der_gesamtzeichnung_obj_aus_300 ()
(terpri)
(princ "\nKeine Objekte des Objekttyps ")
(princ code0)
(princ " in der Gesamtzeichnung gefunden.")
(princ))
(defun c:obj_aus ( / erster_layer layername eigenschaftenliste flag_70 naechster_layer layername_n default_obj_aus code0 auswahlsatz_obj_aus_300_g af_mittelpunkt af_hoehe aufloesung pixel_breit pixel_hoch af_breite p1 p2 auswahlsatz_obj_aus_300_a objekt objektname entityliste ent filter option_obj_aus entity_anzahl entity_nummer entity_name entity_list entity_list_neu objekt_anzahl error_akt version cmdecho_akt version_obj_aus)
(setq error_akt *error*)
(setq *error* *obj_aus_error*)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
(gesperrte_layer_test_obj_aus_300)
(default_setzen_obj_aus_300)
(objekttypwahl_obj_aus_300)
(anzeige_des_gewaehlten_objekttyps_obj_aus_300)
(optionsermittlung_obj_aus_300)
(if (= option_obj_aus "Gesamtzeichnung")
(gesamtzeichnung_obj_aus_300))
(if (= option_obj_aus "Ansichtsfenster")
(ansichtsfenster_obj_aus_300))
(if (and (= option_obj_aus "Gesamtzeichnung") (/= auswahlsatz_obj_aus_300_g nil))
(unsichtbarschalten_g_obj_aus_300))
(if (and (= option_obj_aus "Ansichtsfenster") (/= auswahlsatz_obj_aus_300_a nil))
(unsichtbarschalten_a_obj_aus_300))
(if (and (= option_obj_aus "Ansichtsfenster") (= auswahlsatz_obj_aus_300_a nil))
(keine_objekte_im_ansichtsfenster_obj_aus_300))
(if (and (= option_obj_aus "Gesamtzeichnung") (= auswahlsatz_obj_aus_300_g nil))
(keine_objekte_in_der_gesamtzeichnung_obj_aus_300))
(if (/= objektname nil)
(redraw objektname 4))
(setvar "CMDECHO" cmdecho_akt)
(setq auswahlsatz_obj_aus_300_a nil)
(setq auswahlsatz_obj_aus_300_g nil)
(setq *error* error_akt)
(princ))
(setq version_obj_aus (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_obj_aus 13) (> version_obj_aus 15))
(princ "\nAutoLISP-Tool OBJ_AUS geladen."))
(if (= version_obj_aus 13)
(princ "\nAutoLISP-Tool OBJ_AUS fr AutoCAD 13 geladen."))
(if (= version_obj_aus 14)
(princ "\nAutoLISP-Tool OBJ_AUS fr AutoCAD 14 geladen."))
(if (= version_obj_aus 15)
(princ "\nAutoLISP-Tool OBJ_AUS fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit OBJ_AUS auf. ")
(setq version_obj_aus nil)
(princ)
(terpri)

;**************************************************************************

;OBJ_ISO.LSP

;Programmiert von Gerhard Rampf am 01.04.2000

(defun *obj_iso_error* (cmd)
(princ cmd)
(setq *error* error_akt)
(if (/= cmdecho_akt nil)
(setvar "CMDECHO" cmdecho_akt))
(if (/= objektname nil)
(redraw objektname 4))
(setq erster_layer nil)
(setq layername nil)
(setq eigenschaftenliste nil)
(setq flag_70 nil)
(setq naechster_layer nil)
(setq layername_n nil)
(setq default_obj_iso nil)
(setq objekt nil)
(setq objektname nil)
(setq entityliste nil)
(setq ent nil)
(setq filter nil)
(setq code0 nil)
(setq auswahlsatz_obj_iso_300_g nil)
(setq af_mittelpunkt nil)
(setq af_hoehe nil)
(setq aufloesung nil)
(setq pixel_breit nil)
(setq pixel_hoch nil)
(setq af_breite nil)
(setq p1 nil)
(setq p2 nil)
(setq auswahlsatz_obj_iso_300_a nil)
(setq option_obj_iso nil)
(setq gesamtchek_obj_iso_300 nil)
(setq ansichtchek_obj_iso_300 nil)
(setq entity_anzahl nil)
(setq entity_nummer nil)
(setq zaehlerbasis nil)
(setq entity_name nil)
(setq entity_list nil)
(setq entity_list_neu_unsichtbar nil)
(setq entity_list_neu nil)
(setq error_akt nil)
(setq version nil)
(setq cmdecho_akt nil)
(setq version_obj_iso nil)
(princ))
(defun gesperrte_layer_test_obj_iso_300 ()
(setq erster_layer (tblnext "LAYER" T))
(setq layername (cdr (assoc 2 erster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(if (and (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(setq naechster_layer (tblnext "LAYER")))
(while (and (/= naechster_layer nil) (/= flag_70 4) (/= flag_70 6) (/= flag_70 20) (/= flag_70 22) (/= flag_70 36) (/= flag_70 38) (/= flag_70 52) (/= flag_70 54) (/= flag_70 68) (/= flag_70 70) (/= flag_70 84) (/= flag_70 86) (/= flag_70 100) (/= flag_70 102) (/= flag_70 116) (/= flag_70 118))
(progn
(setq layername_n (cdr (assoc 2 naechster_layer)))
(setq eigenschaftenliste (tblsearch "LAYER" layername_n))
(setq flag_70 (cdr (assoc 70 eigenschaftenliste)))
(if (or (= flag_70 4) (= flag_70 6) (= flag_70 20) (= flag_70 22) (= flag_70 36) (= flag_70 38) (= flag_70 52) (= flag_70 54) (= flag_70 68) (= flag_70 70) (= flag_70 84) (= flag_70 86) (= flag_70 100) (= flag_70 102) (= flag_70 116) (= flag_70 118))
(progn
(princ "\nObjekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")
(alert "Objekte auf gesperrten Layern werden nicht unsichtbar geschaltet.")))
(setq naechster_layer (tblnext "LAYER")))))
(defun vorgabeermitteln_obj_iso_300 ()
(if (= vorgabe_obj_iso_am_300 "3DFACE")
(setq default_obj_iso "3D-FLCHE"))
(if (and (< version 14) (= vorgabe_obj_iso_am_300 "3DSOLID"))
(setq default_obj_iso "FESTKRPER"))
(if (and (= version 14) (= vorgabe_obj_iso_am_300 "3DSOLID"))
(setq default_obj_iso "VOLUMENKRPER"))
(if (and (> version 14) (= vorgabe_obj_iso_am_300 "3DSOLID"))
(setq default_obj_iso "3D-VOLUMENKRPER"))
(if (= vorgabe_obj_iso_am_300 "ARC")
(setq default_obj_iso "BOGEN"))
(if (and (< version 15) (= vorgabe_obj_iso_am_300 "ATTDEF"))
(setq default_obj_iso "ATTRIBUTSBEZEICHNUNG"))
(if (and (> version 14) (= vorgabe_obj_iso_am_300 "ATTDEF"))
(setq default_obj_iso "ATTRIBUT"))
(if (and (= version 13) (= vorgabe_obj_iso_am_300 "BODY"))
(setq default_obj_iso "KRPER"))
(if (and (= version 14) (= vorgabe_obj_iso_am_300 "BODY"))
(setq default_obj_iso "ACIS-FLCHE"))
(if (and (> version 14) (= vorgabe_obj_iso_am_300 "BODY"))
(setq default_obj_iso "BODY"))
(if (= vorgabe_obj_iso_am_300 "CIRCLE")
(setq default_obj_iso "KREIS"))
(if (= vorgabe_obj_iso_am_300 "DIMENSION")
(setq default_obj_iso "BEMASSUNG"))
(if (= vorgabe_obj_iso_am_300 "ELLIPSE")
(setq default_obj_iso "ELLIPSE"))
(if (= vorgabe_obj_iso_am_300 "HATCH")
(setq default_obj_iso "SCHRAFFUR"))
(if (and (= version 14) (= vorgabe_obj_iso_am_300 "IMAGE"))
(setq default_obj_iso "BILD"))
(if (and (> version 14) (= vorgabe_obj_iso_am_300 "IMAGE"))
(setq default_obj_iso "PIXELBILD"))
(if (= vorgabe_obj_iso_am_300 "INSERT")
(setq default_obj_iso "BLOCKREFERENZ"))
(if (= vorgabe_obj_iso_am_300 "LEADER")
(setq default_obj_iso "FHRUNG"))
(if (= vorgabe_obj_iso_am_300 "LINE")
(setq default_obj_iso "LINIE"))
(if (= vorgabe_obj_iso_am_300 "LWPOLYLINE")
(setq default_obj_iso "LW-POLYLINIE"))
(if (and (< version 15) (= vorgabe_obj_iso_am_300 "MLINE"))
(setq default_obj_iso "MULTILINIE"))
(if (and (> version 14) (= vorgabe_obj_iso_am_300 "MLINE"))
(setq default_obj_iso "MLINIE"))
(if (= vorgabe_obj_iso_am_300 "MTEXT")
(setq default_obj_iso "MTEXT"))
(if (= vorgabe_obj_iso_am_300 "POINT")
(setq default_obj_iso "PUNKT"))
(if (= vorgabe_obj_iso_am_300 "POLYLINE")
(setq default_obj_iso "POLYLINIE"))
(if (= vorgabe_obj_iso_am_300 "RAY")
(setq default_obj_iso "STRAHL"))
(if (= vorgabe_obj_iso_am_300 "REGION")
(setq default_obj_iso "REGION"))
(if (= vorgabe_obj_iso_am_300 "SHAPE")
(setq default_obj_iso "SYMBOL"))
(if (= vorgabe_obj_iso_am_300 "SOLID")
(setq default_obj_iso "SOLID"))
(if (= vorgabe_obj_iso_am_300 "SPLINE")
(setq default_obj_iso "SPLINE"))
(if (= vorgabe_obj_iso_am_300 "TEXT")
(setq default_obj_iso "TEXT"))
(if (= vorgabe_obj_iso_am_300 "TOLERANCE")
(setq default_obj_iso "TOLERANZ"))
(if (= vorgabe_obj_iso_am_300 "TRACE")
(setq default_obj_iso "BAND"))
(if (= vorgabe_obj_iso_am_300 "VIEWPORT")
(setq default_obj_iso "ANSICHTSFENSTER"))
(if (= vorgabe_obj_iso_am_300 "XLINE")
(setq default_obj_iso "KLINIE"))
(if (and (/= vorgabe_obj_iso_am_300 "3DFACE") (/= vorgabe_obj_iso_am_300 "3DSOLID") (/= vorgabe_obj_iso_am_300 "ARC") (/= vorgabe_obj_iso_am_300 "ATTDEF") (/= vorgabe_obj_iso_am_300 "BODY") (/= vorgabe_obj_iso_am_300 "CIRCLE") (/= vorgabe_obj_iso_am_300 "DIMENSION") (/= vorgabe_obj_iso_am_300 "ELLIPSE") (/= vorgabe_obj_iso_am_300 "HATCH") (/= vorgabe_obj_iso_am_300 "IMAGE") (/= vorgabe_obj_iso_am_300 "INSERT") (/= vorgabe_obj_iso_am_300 "LEADER") (/= vorgabe_obj_iso_am_300 "LINE") (/= vorgabe_obj_iso_am_300 "LWPOLYLINE") (/= vorgabe_obj_iso_am_300 "MLINE") (/= vorgabe_obj_iso_am_300 "MTEXT") (/= vorgabe_obj_iso_am_300 "POINT") (/= vorgabe_obj_iso_am_300 "POLYLINE") (/= vorgabe_obj_iso_am_300 "RAY") (/= vorgabe_obj_iso_am_300 "REGION") (/= vorgabe_obj_iso_am_300 "SHAPE") (/= vorgabe_obj_iso_am_300 "SOLID") (/= vorgabe_obj_iso_am_300 "SPLINE") (/= vorgabe_obj_iso_am_300 "TEXT") (/= vorgabe_obj_iso_am_300 "TOLERANCE") (/= vorgabe_obj_iso_am_300 "TRACE") (/= vorgabe_obj_iso_am_300 "VIEWPORT") (/= vorgabe_obj_iso_am_300 "XLINE"))
(setq default_obj_iso vorgabe_obj_iso_am_300)))
(defun objektwahl_obj_iso_300 ()
(if (and (< version 15) (= vorgabe_obj_iso_am_300 nil))
(progn
(setq objekt (entsel "\nObjekttyp durch Objekt whlen: "))
(while (= objekt nil)
(setq objekt (entsel "\nObjekttyp durch Objekt whlen: ")))))
(if (and (< version 15) (/= vorgabe_obj_iso_am_300 nil))
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objekt whlen <" default_obj_iso ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objekt whlen <" default_obj_iso ">: ")))))))
(if (and (> version 14) (= vorgabe_obj_iso_am_300 nil))
(progn
(setq objekt (entsel "\nObjekttyp durch Objektwahl angeben: "))
(while (= objekt nil)
(setq objekt (entsel "\nObjekttyp durch Objektwahl angeben: ")))))
(if (and (> version 14) (/= vorgabe_obj_iso_am_300 nil))
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objektwahl angeben <" default_obj_iso ">: ")))
(while (= objekt nil)
(progn
(initget " ")
(setq objekt (entsel (strcat "\nObjekttyp durch Objektwahl angeben <" default_obj_iso ">: ")))))))
(if (/= objekt "")
(progn
(setq objektname (car objekt))
(redraw objektname 3)
(setq entityliste (entget (car objekt)))
(setq ent (assoc 0 entityliste))
(setq filter (cdr ent))))
(if (= objekt "")
(setq filter vorgabe_obj_iso_am_300))
(setq code0 filter)
(setq vorgabe_obj_iso_am_300 filter))
(defun translation_obj_iso_300 ()
(if (= code0 "3DFACE")
(setq code0 "3D-FLCHE"))
(if (and (< version 14) (= code0 "3DSOLID"))
(setq code0 "FESTKRPER"))
(if (and (= version 14) (= code0 "3DSOLID"))
(setq code0 "VOLUMENKRPER"))
(if (and (> version 14) (= code0 "3DSOLID"))
(setq code0 "3D-VOLUMENKRPER"))
(if (= code0 "ARC")
(setq code0 "BOGEN"))
(if (and (< version 15) (= code0 "ATTDEF"))
(setq code0 "ATTRIBUTSBEZEICHNUNG"))
(if (and (> version 14) (= code0 "ATTDEF"))
(setq code0 "ATTRIBUT"))
(if (and (= version 13) (= code0 "BODY"))
(setq code0 "KRPER"))
(if (and (= version 14) (= code0 "BODY"))
(setq code0 "ACIS-FLCHE"))
(if (and (> version 14) (= code0 "BODY"))
(setq code0 "BODY"))
(if (= code0 "CIRCLE")
(setq code0 "KREIS"))
(if (= code0 "DIMENSION")
(setq code0 "BEMASSUNG"))
(if (= code0 "ELLIPSE")
(setq code0 "ELLIPSE"))
(if (= code0 "HATCH")
(setq code0 "SCHRAFFUR"))
(if (and (= version 14) (= code0 "IMAGE"))
(setq code0 "BILD"))
(if (and (> version 14) (= code0 "IMAGE"))
(setq code0 "PIXELBILD"))
(if (= code0 "INSERT")
(setq code0 "BLOCKREFERENZ"))
(if (= code0 "LEADER")
(setq code0 "FHRUNG"))
(if (= code0 "LINE")
(setq code0 "LINIE"))
(if (= code0 "LWPOLYLINE")
(setq code0 "LW-POLYLINIE"))
(if (and (< version 15) (= code0 "MLINE"))
(setq code0 "MULTILINIE"))
(if (and (> version 14) (= code0 "MLINE"))
(setq code0 "MLINIE"))
(if (= code0 "MTEXT")
(setq code0 "MTEXT"))
(if (= code0 "POINT")
(setq code0 "PUNKT"))
(if (= code0 "POLYLINE")
(setq code0 "POLYLINIE"))
(if (= code0 "RAY")
(setq code0 "STRAHL"))
(if (= code0 "REGION")
(setq code0 "REGION"))
(if (= code0 "SHAPE")
(setq code0 "SYMBOL"))
(if (= code0 "SOLID")
(setq code0 "SOLID"))
(if (= code0 "SPLINE")
(setq code0 "SPLINE"))
(if (= code0 "TEXT")
(setq code0 "TEXT"))
(if (= code0 "TOLERANCE")
(setq code0 "TOLERANZ"))
(if (= code0 "TRACE")
(setq code0 "BAND"))
(if (= code0 "VIEWPORT")
(setq code0 "ANSICHTSFENSTER"))
(if (= code0 "XLINE")
(setq code0 "KLINIE"))
(if (and (/= code0 "3DFACE") (/= code0 "3DSOLID") (/= code0 "ARC") (/= code0 "ATTDEF") (/= code0 "BODY") (/= code0 "CIRCLE") (/= code0 "DIMENSION") (/= code0 "ELLIPSE") (/= code0 "HATCH") (/= code0 "IMAGE") (/= code0 "INSERT") (/= code0 "LEADER") (/= code0 "LINE") (/= code0 "LWPOLYLINE") (/= code0 "MLINE") (/= code0 "MTEXT") (/= code0 "POINT") (/= code0 "POLYLINE") (/= code0 "RAY") (/= code0 "REGION") (/= code0 "SHAPE") (/= code0 "SOLID") (/= code0 "SPLINE") (/= code0 "TEXT") (/= code0 "TOLERANCE") (/= code0 "TRACE") (/= code0 "VIEWPORT") (/= code0 "XLINE"))
(setq code0 code0))
(princ "\nGewhlter Objekttyp = ")
(princ code0)
(princ ".")
(princ)
(terpri))
(defun gesamtzeichnung_obj_iso_300 ()
(setq auswahlsatz_obj_iso_300_g (ssget "X")))
(defun ansichtsfenster_obj_iso_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq auswahlsatz_obj_iso_300_a (ssget "_C" p1 p2)))
(defun optionsermittlung_obj_iso_300 ()
(initget "Gesamtzeichnung Ansichtsfenster")
(if (or (= option_obj_iso_300 nil) (= option_obj_iso_300 "Gesamtzeichnung"))
(progn
(if (> version 14)
(setq option_obj_iso (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Gesamtzeichnung>: ")))
(if (< version 15)
(setq option_obj_iso (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Gesamtzeichnung>: ")))))
(if (= option_obj_iso_300 "Ansichtsfenster")
(progn
(if (> version 14)
(setq option_obj_iso (getkword "\nWirkungsbereich festlegen [Gesamtzeichnung/Ansichtsfenster] <Ansichtsfenster>: ")))
(if (< version 15)
(setq option_obj_iso (getkword "\nWirkungsbereich (Gesamtzeichnung/Ansichtsfenster) <Ansichtsfenster>: ")))))
(if (and (= option_obj_iso_300 nil) (= option_obj_iso nil))
(setq option_obj_iso "Gesamtzeichnung"))
(if (and (/= option_obj_iso_300 nil) (= option_obj_iso nil))
(setq option_obj_iso option_obj_iso_300))
(setq option_obj_iso_300 option_obj_iso))
(defun gesamtzeichnung_pruefung_obj_iso_300 ()
(setq gesamtchek_obj_iso_300 (ssget "X" (list (cons 0 filter)))))
(defun ansichtsfenster_pruefung_obj_iso_300 ()
(setq af_mittelpunkt (getvar "viewctr"))
(setq af_mittelpunkt (trans af_mittelpunkt 1 0))
(setq af_hoehe (getvar "viewsize"))
(setq aufloesung (getvar "screensize"))
(setq pixel_breit (car aufloesung))
(setq pixel_hoch (cadr aufloesung))
(setq af_breite (* af_hoehe (/ pixel_breit pixel_hoch)))
(setq p1 (list (- (car af_mittelpunkt) (/ af_breite 2.0)) (- (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p2 (list (+ (car af_mittelpunkt) (/ af_breite 2.0)) (+ (cadr af_mittelpunkt) (/ af_hoehe 2.0))))
(setq p1 (trans p1 0 1))
(setq p2 (trans p2 0 1))
(setq ansichtchek_obj_iso_300 (ssget "_C" p1 p2 (list (cons 0 filter)))))
(defun unsichtbarschalten_g_obj_iso_300 ()
(setq entity_anzahl (sslength auswahlsatz_obj_iso_300_g))
(setq entity_nummer (- 0.0 1))
(setq zaehlerbasis 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_obj_iso_300_g entity_nummer))
(setq entity_list (entget entity_name))
(if (= (cdr (assoc 0 entity_list)) filter)
(progn
(setq zaehlerbasis (+ zaehlerbasis 1))))
(if (and (= (cdr (assoc 0 entity_list)) filter) (= (cdr (assoc 60 entity_list)) 1))
(progn
(setq entity_list_neu_unsichtbar (subst (cons 60 0) (assoc 60 entity_list) entity_list))
(entmod entity_list_neu_unsichtbar)))
(if (/= (cdr (assoc 0 entity_list)) filter)
(progn
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))))
(entmod entity_list_neu)))
(defun unsichtbarschalten_a_obj_iso_300 ()
(setq entity_anzahl (sslength auswahlsatz_obj_iso_300_a))
(setq entity_nummer (- 0.0 1))
(setq zaehlerbasis 0)
(while (and (< entity_nummer entity_anzahl) (/= entity_nummer (- entity_anzahl 1)))
(setq entity_nummer (1+ entity_nummer))
(setq entity_name (ssname auswahlsatz_obj_iso_300_a entity_nummer))
(setq entity_list (entget entity_name))
(if (= (cdr (assoc 0 entity_list)) filter)
(progn
(setq zaehlerbasis (+ zaehlerbasis 1))))
(if (/= (cdr (assoc 0 entity_list)) filter)
(progn
(if (or (= (cdr (assoc 60 entity_list)) 0) (= (cdr (assoc 60 entity_list)) nil))
(setq entity_list_neu (append entity_list (list (cons 60 1)))))))
(entmod entity_list_neu)))
(defun ergebnisanzeige_g_obj_iso_300 ()
(if (> zaehlerbasis 0)
(progn
(terpri)
(princ zaehlerbasis)
(if (= zaehlerbasis 1)
(princ " Objekt des Objekttyps "))
(if (> zaehlerbasis 1)
(princ " Objekte des Objekttyps "))
(princ code0)
(princ " in der Gesamtzeichnung isoliert.")
(terpri))))
(defun ergebnisanzeige_a_obj_iso_300 ()
(if (> zaehlerbasis 0)
(progn
(terpri)
(princ zaehlerbasis)
(if (= zaehlerbasis 1)
(princ " Objekt des Objekttyps "))
(if (> zaehlerbasis 1)
(princ " Objekte des Objekttyps "))
(princ code0)
(princ " im Ansichtsfenster isoliert.")
(terpri))))
(defun af_auswahl_nil_obj_iso_300 ()
(terpri)
(princ "\nKeine Objekte des Objekttyps ")
(princ code0)
(princ " im Ansichtsfenster gefunden.")
(princ))
(defun gz_auswahl_nil_obj_iso_300 ()
(terpri)
(princ "\nKeine Objekte des Objekttyps ")
(princ code0)
(princ " in der Gesamtzeichnung gefunden.")
(princ))
(defun c:obj_iso ( / erster_layer layername eigenschaftenliste flag_70 naechster_layer layername_n default_obj_iso objekt objektname entityliste ent filter code0 auswahlsatz_obj_iso_300_g af_mittelpunkt af_hoehe aufloesung pixel_breit pixel_hoch af_breite p1 p2 auswahlsatz_obj_iso_300_a option_obj_iso gesamtchek_obj_iso_300 ansichtchek_obj_iso_300 entity_anzahl entity_nummer zaehlerbasis entity_name entity_list entity_list_neu_unsichtbar entity_list_neu error_akt version cmdecho_akt version_obj_iso)
(setq error_akt *error*)
(setq *error* *obj_iso_error*)
(setq version (atoi (substr (getvar "ACADVER") 1 2)))
(setq cmdecho_akt (getvar "CMDECHO"))
(gesperrte_layer_test_obj_iso_300)
(vorgabeermitteln_obj_iso_300)
(objektwahl_obj_iso_300)
(translation_obj_iso_300)
(optionsermittlung_obj_iso_300)
(setvar "CMDECHO" 0)
(if (= option_obj_iso "Gesamtzeichnung")
(gesamtzeichnung_obj_iso_300))
(if (= option_obj_iso "Gesamtzeichnung")
(gesamtzeichnung_pruefung_obj_iso_300))
(if (= option_obj_iso "Ansichtsfenster")
(ansichtsfenster_obj_iso_300))
(if (= option_obj_iso "Ansichtsfenster")
(ansichtsfenster_pruefung_obj_iso_300))
(if (and (= option_obj_iso "Gesamtzeichnung") (/= auswahlsatz_obj_iso_300_g nil) (/= gesamtchek_obj_iso_300 nil))
(unsichtbarschalten_g_obj_iso_300))
(if (and (= option_obj_iso "Gesamtzeichnung") (/= auswahlsatz_obj_iso_300_g nil) (/= gesamtchek_obj_iso_300 nil))
(ergebnisanzeige_g_obj_iso_300))
(if (and (= option_obj_iso "Ansichtsfenster") (/= auswahlsatz_obj_iso_300_a nil) (/= ansichtchek_obj_iso_300 nil))
(unsichtbarschalten_a_obj_iso_300))
(if (and (= option_obj_iso "Ansichtsfenster") (/= auswahlsatz_obj_iso_300_a nil) (/= ansichtchek_obj_iso_300 nil))
(ergebnisanzeige_a_obj_iso_300))
(if (and (= option_obj_iso "Ansichtsfenster") (= ansichtchek_obj_iso_300 nil))
(af_auswahl_nil_obj_iso_300))
(if (and (= option_obj_iso "Gesamtzeichnung") (= gesamtchek_obj_iso_300 nil))
(gz_auswahl_nil_obj_iso_300))
(if (/= objektname nil)
(redraw objektname 4))
(setvar "CMDECHO" cmdecho_akt)
(setq auswahlsatz_obj_iso_300_a nil)
(setq auswahlsatz_obj_iso_300_g nil)
(setq *error* error_akt)
(princ))
(setq version_obj_iso (atoi (substr (getvar "ACADVER") 1 2)))
(terpri)
(if (or (< version_obj_iso 13) (> version_obj_iso 15))
(princ "\nAutoLISP-Tool OBJ_ISO geladen."))
(if (= version_obj_iso 13)
(princ "\nAutoLISP-Tool OBJ_ISO fr AutoCAD 13 geladen."))
(if (= version_obj_iso 14)
(princ "\nAutoLISP-Tool OBJ_ISO fr AutoCAD 14 geladen."))
(if (= version_obj_iso 15)
(princ "\nAutoLISP-Tool OBJ_ISO fr AutoCAD 2000 geladen."))
(princ "\nRufen Sie den Befehl mit OBJ_ISO auf. ")
(setq version_obj_iso nil)
(princ)
(terpri)